﻿

var pictureSource; // picture source
var destinationType; // sets the format of returned value
var metadataFile = 'savedEntriesMeta.txt'; //file used to track saved journal entries

var originalMainDataSource;

// Wait for device API libraries to load
//
document.addEventListener("deviceready", onDeviceReady, false);
// device APIs are available
//

//controls the total number of photos we allow
var maxPhotos = 3;
var currPhotos = 0;

var puImages = new kendo.data.DataSource({
    data: [{ imagesrc: "images/icons/camera_icon@2x.png", action: "javascript:capturePhoto();", altText:"take new photo" }]
});

var currentPhotoId = 1;

//test function i use for doign image operations in ripple, since publishing to a device is tedious
function test() {
    //var scrollview = $("#scrollView").data("kendoMobileScrollView");
    ////scrollview.setDataSource([{ imagesrc: imageURI, action: "javascript:void(0);" }, { imagesrc: "images/icons/camera_icon@2x.png", action: "javascript:capturePhoto();" }]);

    //scrollview.content('<div class="photo" data-role="page" aria-hidden="true" id="photodiv4"><a href="javascript:capturePhoto();"><img src="images/icons/get_help.png" class="photo undraggable" id="image4" /></a></div>');


    var scrollview = $("#scrollView").data("kendoMobileScrollView");

    var data = puImages.data();
    var dataItem = data[data.length - 1];

    //simulate the 'insert' functionality
   // var dataItem = puImages.at(0);
    puImages.remove(dataItem);
    puImages.add({ imagesrc: "images/icons/get_help.png", action: "javascript:void(0);" });
    puImages.add(dataItem);

    
    scrollview.setDataSource(puImages);
}



function onDeviceReady() {
    pictureSource = navigator.camera.PictureSourceType;
    destinationType = navigator.camera.DestinationType;

   
    //kendoConsole.log("log initialized");

}
// Called when a photo is successfully retrieved
//

//function onPhotoDataSuccess(imageURI) {
//    //view the base64-encoded image data
//    //console.log(imageURI);

//    currPhotos++;
   
//    var cameraImage = document.getElementById('image');
//    var scrollview = $("#scrollView").data("kendoMobileScrollView");

//    puImages[0] = { imagesrc: imageURI, action: "javascript:void(0);", altText: "user photo" };
//    scrollview.setDataSource(puImages);
   
//    //simulate the 'insert' functionality.  remove the last item, which is the 'add new photo' item
//    var data = puImages.data();
//    var dataItem = data[data.length - 1];
//    puImages.remove(dataItem);
   
//    // var dataItem = puImages.at(0);
//    var stringTest = "" + imageURI + "";
//    //kendoConsole.load("String equals URI? " + stringTest === imageURI);

//    //add the new image to the array
//    puImages.add({ imagesrc: imageURI, action: "javascript:void(0);", altText: "user photo" });

//    //if youre not at the max, re-add the 'add new photo' item
//    if ((data.length) < maxPhotos) {
//        puImages.add(dataItem);
//    }

//    scrollview.setDataSource(puImages);
//}
//// Called when a photo is successfully retrieved
////

//function onPhotoURISuccess(imageURI) {
//    // Uncomment to view the image file URI
//    console.log(imageURI);
//    // Get image handle
//    //
//    var galleryImage = document.getElementById('image');
//    // Unhide image elements
//    //
//    galleryImage.style.display = 'block';
//    // Show the captured photo
//    // The inline CSS rules are used to resize the image
//    //
//    galleryImage.src = imageURI;
//}


//function capturePh() {

//    currPhotos++;

//    //var cameraImage = document.getElementById('image');
//    var scrollview = $("#scrollView").data("kendoMobileScrollView");

//    //set the image
//    mainDataSource.getByUid(currentUID).childData.getByUid(currentPhotoId).set("image", "images\learn\add-med-team-sm.png");



//    //rebind the grid
//    e.view.element.find("#detail-listview").kendoMobileListView({
//        dataSource: mainDataSource.getByUid(currentUID).childData,
//        template: "<img src='${image}' class='detailImage' aria-hidden='true'></img><h2 class='detailText'>${name}</h2>"
//    });
//}

function onPhotoDataSuccess(imageURI) {

    //this is the filename of the image being created...for whatever reason it does this now
    console.log("ImageURI: " + imageURI);

    var imageUrl = imageURI;
    convertImgToBase64(imageUrl, function (base64Img) {

        //console.log("conversion done");
        //console.log("Real base64: " + base64Img);

        currPhotos++;

        var d = new Date();

        //set the image. this also refreshes the listview since it's bound by reference
        mainDataSource.getByUid(currentUID).childData.getByUid(currentPhotoId).set("image", base64Img);
        mainDataSource.getByUid(currentUID).childData.getByUid(currentPhotoId).set("hasPhoto", 1);
        mainDataSource.getByUid(currentUID).childData.getByUid(currentPhotoId).set("date", getFormattedDateString(d));

    });

    
}
// Called when a photo is successfully retrieved
//

function onPhotoURISuccess(imageURI) {
    // Uncomment to view the image file URI
    //console.log(imageURI);
    // Get image handle
    //
    var galleryImage = document.getElementById('image');
    // Unhide image elements
    //
    galleryImage.style.display = 'block';
    // Show the captured photo
    // The inline CSS rules are used to resize the image
    //
    galleryImage.src = imageURI;
}

function capturePhoto() {
    // Take picture using device camera and retrieve image as base64-encoded string
    navigator.camera.getPicture(onPhotoDataSuccess, onFail, {
        quality: 70,
        targetWidth: 250,
        targetHeight: 250,
        destinationType: destinationType.FILE_URI,
        saveToPhotoAlbum: false
    });
}


function getPhoto(source) {
    // Retrieve image file location (the camera roll in most cases)
    navigator.camera.getPicture(onPhotoURISuccess, onFail, {
        quality: 50,
        targetWidth: 500,
        targetHeight: 500,
        destinationType: destinationType.FILE_URI,
        sourceType: source
    });
}

// Called if something bad happens.
function onFail(message) {
    //alert('Failed because: ' + message);
}






//Start the edit/selection code for PU details

var currentAttribute;
var currentUID;
var selectedItems;
var isLoading;
var isLoaded = false;
var loadedFile;



function onListClick(e) {

    //if single-select, then save then back
    if (currentAttribute.type === 1) {
        
          
        mainDataSource.getByUid(currentUID).set("selected", mainDataSource.getByUid(currentUID).childData.getByUid(e.item[0].attributes[0].nodeValue).name); //currentAttribute.childData.getByUid(e.dataItem.uid).name);
       // mainDataSource.sync();
       // console.log("Attribute changed to: " + currentAttribute.selected)

        kendo.mobile.application.navigate("#:back");
    }
    else if (currentAttribute.type === 6 && !isLoaded) {
        //take a photo
        currentPhotoId = e.item[0].attributes[0].nodeValue;
        capturePhoto();
        //capturePh();
    }
    else if (currentAttribute.type === 6 && isLoaded) {
        //open photo in photo viewer page
      
        navigateToURL("html/backpack/photo-viewer.html?imgId=" + e.item[0].attributes[0].nodeValue)
    }
    else {
      
        //toggle the selection style and then record the UID of the selected row into a local array for processing on 'done'
       // e.item.toggleClass("listview-selected");

        var myData = mainDataSource.getByUid(currentUID).childData.getByUid(e.item[0].attributes[0].nodeValue);

        if (selectedItems.inArray(e.item[0].attributes[0].nodeValue)) {

            selectedItems.removeByValue(e.item[0].attributes[0].nodeValue)
           // console.log(e.item);
            mainDataSource.getByUid(currentUID).set("selected", mainDataSource.getByUid(currentUID).childData.getByUid(e.item[0].attributes[0].nodeValue).name); //currentAttribute.childData.getByUid(e.dataItem.uid).name);
            //mainDataSource.getByUid(currentUID).childData.getByUid(e.item[0].attributes[0].nodeValue).set("selected", "false");
            //console.log(mainDataSource.getByUid(currentUID).childData.getByUid(e.item[0].attributes[0].nodeValue).selected)

           
            console.log("selectd: " + myData.selected);
            myData.set("selected", 'false');

            //e.item.attr("aria-selected", "false");
            //e.dataItem.set("selected", "false");
        }
        else {
            selectedItems.push(e.item[0].attributes[0].nodeValue);
            console.log("selectd: " + myData.selected);
            myData.set("selected", 'true');
            //mainDataSource.getByUid(currentUID).childData.getByUid(e.item[0].attributes[0].nodeValue).set("selected", "true");
        }
    }

}

function onLoadedListClick(e) {

}

function loadMainDataWithLoadedString(arrayString) {
    //poplulate the main data source with the saved string values


    var numPhotosLoaded = 0;    //counter to keep track of how many photos have been loaded already

    //make string into an array
    var arrayObject = JSON.parse(arrayString);

    //verify the datasource is populated
   // mainDataSource.read();

    //read the child array of the photo object, it's the only one we need for saved entries
    //mainDataSource.at(15).childData.read();

    var data = mainDataSource.data();

   

    //get the images array set up.  remove the existing item, which is the "add new" image, which we don't need anymore
    //puImages.data([ ]);
   

    //now loop through the saved values and add them back into the main grid and photos
    for (var i = 0; i < arrayObject.length; i++) {
        var entry = arrayObject[i];

        if (entry[0] === "numPhotos") {
            currPhotos = parseInt(entry[1]);
        }
        //else if (entry[0] === "photo") {
        //    //add the new image to the array
        //    puImages.add({ imagesrc: entry[1], action: "javascript:void(0);", altText: "user photo" });
        //}
        else {
            //now find the original entry in the mainDataSource and change the 'selected' field
            for (var x = 0; x < data.length; x++) {
                var dataObject = data[x];
                if (dataObject) {
                    //console.log("Compare: " + dataObject.questionId.toString() + " and " + entry[0].toString() + "  Match : " + (dataObject.questionId.toString() === entry[0].toString()))

                    //find the right questionid so we can map the saved data
                    if (dataObject.questionId.toString() === entry[0].toString()) {

                        if (dataObject.questionId === 15) {
                            //if it's a photo, we need to change how the images are loaded
                            var imageURI = entry[1];
                            console.log("photo: " + numPhotosLoaded);
                            mainDataSource.get(dataObject.questionId).childData.at(numPhotosLoaded).set("image", imageURI);//cset("selected", entry[1]);
                            numPhotosLoaded++;
                        }
                        else {
                            //indexes are 1-based not 0-based on the datasource, so increment x by one
                            mainDataSource.get(dataObject.questionId).set("selected", entry[1]);
                        }
                        
                    }
                }
            }
        }


        mainDataSource.get(15).set("selected",numPhotosLoaded.toString() + " User Photos");

    }
}

function gotLoadedFile(fileEntry) {

    fileEntry.file(function (file) {

       // kendoConsole.log("Start File Load");
        var reader = new FileReader();

        reader.onloadend = function (e) {
            var arrayString = this.result;

            //arrayString = CryptoJS.AES.decrypt(arrayString, "Secret Passphrase");
           //arrayString = CryptoJS.AES.decrypt(arrayString, getKey());
           //arrayString = arrayString.toString(CryptoJS.enc.Utf8);
            
            //console.log(this.result);
            //console.log("Start load result: " + arrayString)
            loadMainDataWithLoadedString(arrayString);

           // kendoConsole.log("data source configured")
           
            //now load up a read-only version
            //$("#list-edit-listview").kendoMobileListView({
            //    dataSource: mainDataSource,
            //    template: $("#itemTemplate").html()
            //});

            //kendoConsole.log("list view populated")

        }

        reader.readAsText(file);
    });

}

var testString = '[["1", "8-nose"],["2", "Blueberry"],["3", "No Value Selected"],["4", "No Value Selected"],["5", "No Value Selected"],["6", "No Value Selected"],["7", "No Value Selected"],["8", "No Value Selected"],["9", "No Value Selected"],["10", "No Value Selected"],["11", "No Value Selected"],["12", "No Value Selected"],["13", "No Value Selected"]]';
var testString2='[["numPhotos", "1"],["15", "file:///var/mobile/Containers/Data/Application/8E1E6EDD-0670-4FE6-B396-94E8C38BCBE7/tmp/cdv_photo_001.jpg"],["1", "Nose"],["2", "No Value Selected"],["3", "No Value Selected"],["4", "No Value Selected"],["5", "No Value Selected"],["6", "No Value Selected"],["7", "No Value Selected"],["8", "No Value Selected"],["10", "No Value Selected"],["9", "No Value Selected"],["11", "No Value Selected"],["12", "No Value Selected"],["13", "No Value Selected"],["14", ""]]';
function listViewInit(e) {

    console.log("entry view initialized");
    mainDataSource.read();
    mainDataSource.get(15).childData.read();
    //loadMainDataWithLoadedString(testString2);
   // originalMainDataSource = mainDataSource;

    //in the init, setup the page and binding situation
    $('#submit-va-button').kendoMobileButton({ click: submitToVA });
    $('#resubmit-va-button').kendoMobileButton({ click: resubmitToVA });

    if (!enableDSLogonTransmission) {
        $('#submitButtonText').text("Save Journal Entry");
    }

    if (e.view.params.load) {

        console.log("loading existing record");

        e.view.element.find("#list-edit-listview").kendoMobileListView({
            dataSource: mainDataSource,
            template: $("#loadedItemTemplate").html()
        })
      .kendoTouch({
          filter: ">li",
          touchstart: touchstart,
          tap: navigate
      });

        loadedFile = e.view.params.load;
        isLoading = true;

        $('#submit-va-button').hide();

        if (enableDSLogonTransmission) {
            $('#resubmit-va-button').show();
        } else {
            $('#resubmit-va-button').hide();
        }

        var filename = e.view.params.load;
        window.resolveLocalFileSystemURL(cordova.file.dataDirectory + filename, gotLoadedFile, fail);

    }
    else {

        //create a new journal entry
        currPhotos = 0;

        $('#resubmit-va-button').hide();

        var message = "Always check your skin from head-to-toe before you make your journal entry. Ask your caregiver if you need help. Your medical team may not see this entry, so if you have questions, concerns, or problems, call your medical team or 911 right away.";


        e.view.element.find("#list-edit-listview").kendoMobileListView({
            dataSource: mainDataSource,
            template: $("#journalItemTemplate").html()
        })
        .kendoTouch({
            filter: ">li",
            enableSwipe: true,
            touchstart: touchstart,
            tap: navigate
        });


        //TEMP HACK dont know why it doesn't work
        //alert(message);
        navigator.notification.alert(
                       message,    // message
                       void (0),   // callback
                       'Check Skin Reminder',      // title
                       'Ok'  // buttonName
                   );

    }

}

function navigate(e) {
    var itemUID = $(e.touch.currentTarget).data("uid");
    var model = mainDataSource.getByUid(itemUID);

    if (isLoaded) {
        //the only click event we want is the photos one when we load
        if (model.id === 15) {
            kendo.mobile.application.navigate("#edit-detailview?uid=" + itemUID);
        }
    }
    else {
        if (model.type === 3) {
            kendo.mobile.application.navigate("#edit-sliderview?uid=" + itemUID);
        }
        else if (model.type === 4) {
            kendo.mobile.application.navigate("#edit-whereview?uid=" + itemUID);
        }
        else if (model.type === 5) {
            kendo.mobile.application.navigate("#edit-notesview?uid=" + itemUID);
        }
        else {
            kendo.mobile.application.navigate("#edit-detailview?uid=" + itemUID);
        }
    }
}

function touchstart(e) {
    var target = $(e.touch.initialTouch),
        listview = $("#list-edit-listview").data("kendoMobileListView"),
        model,
        button = $(e.touch.target).find("[data-role=button]:visible");

    if (target.closest("[data-role=button]")[0]) {
        model = mainDataSource.getByUid($(e.touch.target).attr("data-uid"));
        dataSource.remove(model);

        //prevent `swipe`
        this.events.cancel();
        e.event.stopPropagation();
    } else if (button[0]) {
        button.hide();

        //prevent `swipe`
        this.events.cancel();
    } else {
        listview.items().find("[data-role=button]:visible").hide();
    }
}

function mainShow(e) {

    if (isLoading) {
        isLoading = false;
        isLoaded = true;
        window.resolveLocalFileSystemURL(cordova.file.dataDirectory + loadedFile, gotLoadedFile, failFileOp);

    }
    else {
        var mainList = $('#list-edit-listview').data('kendoMobileListView');
        //mainList.dataSource.read();   // do this if you want to restore the 'original'
        mainList.refresh();
    }
   
}

//Methods for the listview-style details

function detailShow(e) {
    var model = mainDataSource.getByUid(e.view.params.uid);
    currentAttribute = model;
    currentUID = e.view.params.uid;

    var navbar = app.view()
    .header
    .find(".km-navbar")
    .data("kendoMobileNavBar");

    navbar.title(model.title);

    //reset scroll position
    resetScrollPosition(e);
   
    //read in existing items
    selectedItems = new Array();

    //if it's a multi-select, we need to pre-select the items
    if (model.type === 2) {

    }


    if (model.instructions) {
        //show the description panel
        e.view.element.find("#instructionsPanel").show();
        $("#instructionsText").text(model.instructions);
    }
    else {
        e.view.element.find("#instructionsPanel").hide();
    }
    if (model.childData.data().length === 0) {
        model.childData.read();
    }
  

    //hide both listviews first, we'll decide which to show later
    e.view.element.find("#detail-listview-pain").hide();
    e.view.element.find("#detail-listview").hide();

    if (model.childData.at(0).color) {

        e.view.element.find("#detail-listview-pain").show();
  
        e.view.element.find("#detail-listview-pain").kendoMobileListView({
            dataSource: model.childData,
            template: $("#painScaleTemplate").html()
        });

    }
    else if (model.childData.at(0).image) {
        e.view.element.find("#detail-listview").show();
        e.view.element.find("#detail-listview").kendoMobileListView({
            dataSource: model.childData,
            template: "<div role='button' class='simpleListButton'><img src='${image}' class='detailImage' aria-hidden='true'></img><h2 class='detailText'>${name}</h2></div>"
        })
    }
    else if(model.type === 2){
        e.view.element.find("#detail-listview").show();
        e.view.element.find("#detail-listview").kendoMobileListView({
            dataSource: model.childData,
            template: $("#itemDetailTemplate").html()
        })
    }
    else {
        e.view.element.find("#detail-listview").show();
        e.view.element.find("#detail-listview").kendoMobileListView({
            dataSource: model.childData,
            template: $("#simpleitemDetailTemplate").html()
        })
    }
}

function detailInit(e) {
    var view = e.view;

    //add click event to the listview
    e.view.element.find("#detail-listview").kendoMobileListView({
        click: onListClick
    });
    e.view.element.find("#detail-listview-pain").kendoMobileListView({
        click: onListClick
    });

    //view.element.find("#done").data("kendoMobileButton").bind("click", function () {
    //    mainDataSource.one("change", function () {
    //        view.loader.hide();
    //        kendo.mobile.application.navigate("#:back");
    //    });

    //    view.loader.show();
    //    mainDataSource.sync();
    //});

    //bind events to the 'done' button that handles all the saving

    view.element.find("#done").kendoMobileButton({
        click: function () {

            //view.element.find("#done").data("kendoMobileButton").bind("click", function () {

            //e.preventDefault();
            //mainDataSource.one("change", function () {
            //    view.loader.hide();
            //    kendo.mobile.application.navigate("#:back");
            //});

            //view.loader.show();
            //mainDataSource.cancelChanges();
            if (currentAttribute.type === 2) {

                var i;
                var stringValue = '';
                for (i = 0; i < selectedItems.length; i++) {
                    var uid = selectedItems[i];
                    mainDataSource.getByUid(currentUID).childData.getByUid(uid).set("selected", 1);
                    stringValue += mainDataSource.getByUid(currentUID).childData.getByUid(uid).name + ',';
                }
                //cut off the last comma
                stringValue = stringValue.substring(0, stringValue.length - 1);

                if (selectedItems.length === 0)
                    stringValue = "No Value Selected";

                mainDataSource.getByUid(currentUID).set("selected", stringValue);
            } else if (currentAttribute.type === 6) {
                mainDataSource.getByUid(currentUID).set("selected", (currPhotos != 1 ? currPhotos.toString() + " user photos" : "1 user photo"));
            }


            kendo.mobile.application.navigate("#:back");

        }
    });
}


//Methods for the slider-style details

function sliderShow(e) {

    var model = mainDataSource.getByUid(e.view.params.uid);
    currentAttribute = model;
    currentUID = e.view.params.uid;

    //fetch data first so we know it's loaded
    model.childData.fetch();

    var datasourcedata = model.childData.data()


    //set up the slider and the change events
    $("#slider-vertical").slider({

        orientation: "vertical",
        range: "min",
        min: 0,
        max: model.childData.total()-1,
        value: sliderGetSelectedIndex(),
        step: 1,
        slide: function (event, ui) {

            //fetch the name of the data item selected
            var datasourcedata = mainDataSource.getByUid(currentUID).childData.data();
            for (var i = 0; i < datasourcedata.length; i++) {
                if (i === ui.value) {
                    $("#amount").val(datasourcedata[i].name);
                }
            }
        }
    });
    console.log($(window).height());
    $("#slider-vertical").height($(window).height()*.8)


    $("#amount").val(datasourcedata[$("#slider-vertical").slider("value")].name);
     

    //set up the images
       
    var leftData = '';
    var rightData = '';

    //if we have the alternating-style
    if (datasourcedata.length > 6) {
        var side = 0;
        for (var i = datasourcedata.length - 1; i > -1 ; i--) {
            var imageSrc = datasourcedata[i].image;
            var name = datasourcedata[i].name;
            if (side === 0) {
                leftData += '<img src="' + imageSrc + '" alt="' + name + '" class="leftSideImage" />';
                side = 1;
            }
            else {
                rightData += '<img src="' + imageSrc + '" alt="' + name + '" class="leftSideImage" />';
                side = 0;
            }
        }

    }
    else {
        //if it's just one side
        for (var i = 0; i < datasourcedata.length; i++) {
            if (datasourcedata[i].image) {
                var imageSrc = datasourcedata[i].image;
                leftData += '<br /><br /><br /><img src="' + imageSrc + '" alt="' + name + '" /><br /><br />';
                console.log(leftData);
            }
        }
    }

    $("#leftImageContainer").html(leftData);
    $("#rightImageContainer").html(rightData);


 
}

function sliderGetSelectedIndex() {
  
    var selectedValue = 0;

    var datasourcedata = mainDataSource.getByUid(currentUID).childData.data();
    for (var i = 0; i < datasourcedata.length; i++) {

        if (currentAttribute.selected === datasourcedata[i].name) {
            selectedValue = i;
        }
    }

    return selectedValue;
}

function sliderInit(e) {

    var view = e.view;

    view.element.find("#done").data("kendoMobileButton").bind("click", function () {

        mainDataSource.getByUid(currentUID).set("selected", $('#amount').val());
        kendo.mobile.application.navigate("#:back");
    });

}



function notesShow(e) {

    var model = mainDataSource.getByUid(e.view.params.uid);
    currentAttribute = model;
    currentUID = e.view.params.uid;

   
   

    if (isLoaded) {
        $("#notesText").text(model.selected);
        $("#writeNotesDiv").hide();
        $("#viewNotesDiv").show();
    }
    else {
        $("#notesInput").val(model.selected);
        $("#writeNotesDiv").show();
        $("#viewNotesDiv").hide();
    }
    
   

}

function notesInit(e) {

    var view = e.view;

    //view.element.find("#done").data("kendoMobileButton").bind("click", function () {
    view.element.find("#done").kendoMobileButton({ click: notesSaveAndBack });

}

    function notesSaveAndBack(){
        mainDataSource.getByUid(currentUID).set("selected", $('#notesInput').val());
        kendo.mobile.application.navigate("#:back");
    }


//Methods and Variables for the custom body map viewer

var init = 0 //hack, was getting initialized twice for some reason
var currentBodyIndex = 0;
var gender = 0;
var lastImage = 'none';


function setMale() {
    gender = 0;
    $('#maleButton').attr('aria-selected', true)
    $('#femaleButton').attr('aria-selected', false)
    reset();
}
function setFemale() {
    gender = 1;
    $('#maleButton').attr('aria-selected', false)
    $('#femaleButton').attr('aria-selected', true)
    reset();
}

function hideAllBodyMaps() {
     $(".bodyImageContainer img").hide();

    // $(".bodyImageDiv").hide();
    //$(".bodyImageContainer div").hide();
   
}
function reset() {
    selectRootImage(currentBodyIndex);
    $("#undoButton").hide();
}
function selectImageWithName(imageName) {

    $("#resultText").html('');
    hideAllBodyMaps();
    // $(lastImage+'Div').hide();

    var divName = imageName + 'Div'
   // $(divName).show();
    $(imageName).show();

    if (lastImage === 'none') {
        // console.log('first time through select with div: ' + divName);
        // $(imageName).height('inherit');
    }
    else {
        $(imageName).height('inherit');
        console.log('height inherited');
    }


    // $(imageName).maphilight();
    lastImage = imageName;

}

function selectRootImage(index) {

    $("#undoButton").hide();

    var imageToShow;

    if (index === 0) {
        imageToShow = 'front';
    }
    else if (index === 1) {
        imageToShow = 'back';
    }
    else if (index === 2) {
        imageToShow = 'left'
    }
    else if (index === 3) {
        imageToShow = 'right'
    }

    if (gender === 0) { imageToShow = imageToShow + 'MaleImage'; } else { imageToShow = imageToShow + 'FemaleImage'; }
    imageToShow = "#" + imageToShow;
    selectImageWithName(imageToShow);

}

function bodyShow(e) {
    var model = mainDataSource.getByUid(e.view.params.uid);
    currentAttribute = model;
    currentUID = e.view.params.uid;

    //preload with saved data
    $("#resultText").html(model.selectedValue);

   // selectRootImage(0);

    setTimeout(function() {
     selectRootImage(0);
    }, 300);

    console.log("maps shown");

}

function bodyInit(e) {


    //set up the buttons with click events
    $('#maleButton').kendoMobileButton({ click: setMale });
    $('#femaleButton').kendoMobileButton({ click: setFemale });
    $('#undoButton').kendoMobileButton({ click: reset });

    var view = e.view;

    if (init === 0) {
        init = 1;
        $('img[usemap]').rwdImageMaps();
        //$('img[usemap]').maphilight();


        $("#select-body-direction").kendoMobileButtonGroup({
            select: function (e) {
                currentBodyIndex = e.index;
                selectRootImage(e.index);

                //set aria-selected attributes for each item
                //jak
               
            }
            , index: 0
        });

        $('.bodyImageMaps map area').on('mousedown', function () {

            $("#undoButton").show();
            var toBeSelected = $(this).attr('data-location-code');
            var tempDataSource = mapLinksDataSource;

            tempDataSource.filter({ field: "code", operator: "equals", value: toBeSelected });

            var view = tempDataSource.view();
            if (view.length > 0) {
                selectImageWithName('#' + view[0].image);
            }
            else {
                //this is a 'final' image, so we need to record the value

                var tempBodyDataSource = bodyTermsDataSource;

                tempBodyDataSource.filter({ field: "code", operator: "equals", value: toBeSelected });
                var bodyView = tempBodyDataSource.view();
                $("#resultText").html(bodyView[0].commonName);
                mainDataSource.getByUid(currentUID).set("selected", bodyView[0].commonName);
                //kendo.mobile.application.navigate("#:back");
            }

        });

        view.element.find("#done").kendoMobileButton({ click: navigateBack });

        console.log("maps initialized");

    }


}

function navigateBack() {
    kendo.mobile.application.navigate("#:back");
}

function resubmitToVA() {
    //TODO:  Implement this somehow once we figure out how it's gonna be handled.
}

function submitToVA() {

    //to be implemented, test with the web service they sent us

    console.log("testing submit binding")
  

    //first validate the records
    if (validateJournalEntry()) {
        
        //then convert array to string that's usable
        var savedDataString = buildSavedJournalEntryObject();

        //now write out the item to disk
        writeJournalEntryToDisk(savedDataString);


        //do i still need this?  seems ot just refresh the viewable list, which seems unnecessary
        mainDataSource = originalMainDataSource;
        loadMainDataWithLoadedString(savedDataString);
        $("#list-edit-listview").kendoMobileListView({
            dataSource: mainDataSource,
            template: $("#journalItemTemplate").html()
        });
        //end do i still need this


        //build JSON for eCRUD transmission
        //sendJournalEntry();
        if (enableDSLogonTransmission) {
            var postableObject = buildPostableObject();
            //TODO:  finalize transmission protocols and post object
        }
    }

    //app.navigate("html/health/login.html");

}



function buildPostableObject() {

    var d = getFormattedDateString(new Date());

    var myJSONObject = {
        "patientId": "EDIPIfromVAMFDSLogonService", "submissionDate": d, "images": [], "patientValues": { "appearance": [] }, "providerValues": { "appearance": [] }, "Notes": ""
    };

    var data = mainDataSource.data();
    for (var i = 0; i < data.length; i++) {

        //exclude notes and photos, we'll do those later
        if (data[i] && data[i].questionId != 15 && data[i].questionId != 7 && data[i].questionId != 14) {
            // console.log(data[i].questionId + ", " + data[i].selected)

            //check if it's one of the multiple answer questions
            if (data[i].questionId === 3) {
                var appearanceArray =  data[i].selected.split(',');

                for(var k=0;k<appearanceArray.length;k++){
                    var appearanceValue = { "value": appearanceArray[k] }
                    myJSONObject.patientValues["appearance"].push(appearanceValue);
                    myJSONObject.providerValues["appearance"].push(appearanceValue);
                }

            } else {
                //otherwise just set the value
                myJSONObject.patientValues[data[i].shortTitle] = data[i].selected;
                myJSONObject.providerValues[data[i].shortTitle] = data[i].selected;
            }
           
        }
        else if (data[i] && data[i].questionId === 15) {
            var photoData = data[i].childData.data();
           
            for (var j = 0; j < 3; j++) {
                if (photoData[j].hasPhoto === 1) {
                    var imageString = '"' + photoData[j].image + '"';
                    var dateString = '"' + photoData[j].date + '"';
                    var imageObject = { "image": imageString, "imageDate": dateString };
                    myJSONObject['images'].push(imageObject);
                   
                }
            }

        }
        else if (data[i] && data[i].questionId === 14) {
            myJSONObject["Notes"] = data[i].selected;
        }
    }

    console.log("JSON Object: " + myJSONObject);
    console.log("Stringified: " + JSON.stringify(myJSONObject));

    return myJSONObject;
}

function sendJournalEntry() {

    console.log("begin transmission");
    //userame/password for the endpoint?
    var endpoint = pgdEndpoint + 'token?grant_type=password&client_id={' + pgdClientId + '}&username={}&password={}';
    var jsonObject = buildPostableObject();

    $.ajax
    ({
        type: "POST",
       
        url: endpoint,
        dataType: 'json',
        async: true,
        timeout: 60000,
        //json object to sent to the authentication url
        data: jsonObject,
        success: function () {

            alert("transmission complete!");
        },
        error: function () { console.log("error sendign");alert(data); }

    
    })
}

function validateJournalEntry() {
    return true;
}

function buildSavedJournalEntryObject(){

    var string = '[';

    //build the image capture data
    //first, we need a record of how many images there are
    string += '["numPhotos", "' + currPhotos + '"],'


    //add the fields of mainDataSource and build a [questionId, selectedValue] array item
    var data = mainDataSource.data();
    for (var i = 0; i < data.length; i++) {
        if (data[i] && data[i].questionId != 15) {
            console.log(data[i].questionId + ", " + data[i].selected)
            string += '["' + data[i].questionId + '", "' + data[i].selected + '"],'
        }
        else if (data[i] && data[i].questionId === 15) {
            var photoData = data[i].childData.data();
            for (var j = 0; j < 3; j++) {
                if (photoData[j].hasPhoto === 1) {
                    //if it has a photo, write it to disk
                    string += '["' + data[i].questionId + '", "' + photoData[j].image + '"],'
                }
            }
        }
    }

    //cut off the last comma
    string = string.substr(0, string.length-1); 

    string += ']';

    return string;

}

function writeJournalEntryToDisk(journalString) {
    //We need to write both the journal entry file, as well as the metadata file.  Metadata file is used for the saved entries
    //so that we dont' need to load every file just to browse the list.  


    var d = new Date();
    var dateString = (d.getMonth() + 1) + '-' + (d.getDate()) + '-' + d.getFullYear();

    var data = mainDataSource.data();
    var locationString = data[1].selected;
    var filename = dateString.replace("-", "") + Math.floor((Math.random() * 10000) + 1) + '.txt';

    //encrypt metadata
    var metadataString = '{ "filename": "' + filename + '", "date" : "' + dateString + '", "location" : "' + locationString + '"},';
    // metadataString = CryptoJS.AES.encrypt(metadataString, getKey());

     window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function (dir) {
    
        //save the record as a separate file

        dir.getFile(filename, { create: true }, function (file) {
            
            var logOb = file;

            logOb.createWriter(function (fileWriter) {

                fileWriter.seek(fileWriter.length);

              
                //encrypt stringified journal entry
                //journalString = CryptoJS.AES.encrypt(journalString, getKey());
                fileWriter.write(journalString);

                var title = "Submission Successful";
                var message = "Your Journal Entry was saved to your device. If you have a question, concern, or problem, call your medical team or 911 IMMEDIATELY.";

                console.log('entry written');
                navigator.notification.alert(
                      message,    // message
                      void (0),   // callback
                      title,      // title
                      'Ok'  // buttonName
                  );

                navigateToURL('html/health/journal-home.html');

            }, fail);
           
        });

        //write a line of metadata to the 'main' log that feeds the past PU list as JSON
        dir.getFile(metadataFile, { create: true }, function (file) {
           
            var metaOb = file;

            metaOb.createWriter(function (fileWriter) {

                fileWriter.seek(fileWriter.length);
                fileWriter.write(metadataString);

            }, failFileOp);

        });

    });

}

var fail = function (evt) {
    kendoConsole.log(error.code);
};


    //data sources.  define the sub-element data sources first, then finally at the end the main data source
    //because otherwise they are undefined.  in the future, maybe pull this out into a json or xml file rather
    //than putting them all in the .js file

    var whatDataSource = new kendo.data.DataSource({
        data: [
          { name: "Round", image: "images\\details\\round.png" },
          { name: "Oval", image: "images\\details\\oval.png" },
          { name: "Irregular", image: "images\\details\\irregular.png" },
          { name: "Pencil", image: "images\\details\\pencil.png" }
        ]
    });

    var skinDataSource = new kendo.data.DataSource({
        data: [
          { name: "Blister", selected:false },
          { name: "Boil", selected: false },
          { name: "Scrape (Abrasion)", selected: false },
          { name: "Tear", selected: false },
          { name: "Cut (Laceration)", selected: false },
          { name: "Skin Attached", selected: false },
          { name: "Skin Removed", selected: false }
        ]
    });

    var smellDataSource = new kendo.data.DataSource({
        data: [
          { name: "No Smell" },
          { name: "Slight" },
          { name: "Moderate" },
          { name: "Strong" },
          { name: "Foul" },
          { name: "Sweet" }
        ]
    });

    var colorDataSource = new kendo.data.DataSource({
        data: [
          { name: "Pink", image: "images\\details\\colors\\pink.png" },
          { name: "Red", image: "images\\details\\colors\\red.png" },
          { name: "Purple", image: "images\\details\\colors\\purple.png" },
          { name: "Black", image: "images\\details\\colors\\black.png" },
          { name: "Green", image: "images\\details\\colors\\green.png" },
          { name: "Yellow", image: "images\\details\\colors\\yellow.png" },
          { name: "Tan or Brown", image: "images\\details\\colors\\brown-tan.png" },

        ]
    });

    var whenDataSource = new kendo.data.DataSource({
        data: [
          { name: "Hardly ever" },
          { name: "Sometimes" },
          { name: "Always" }
        ]
    });

    var painLevelDataSource = new kendo.data.DataSource({
        data: [
          { name: "0 - No Pain", color: "#527400", image: "images\\details\\faces\\vapain0-2a.png" },
          { name: "1 - Hardly notice pain", color: "#527400", image: "images\\details\\faces\\vapain0-2b.png" },
          { name: "2 - Notice pain", color: "#527400", image: "images\\details\\faces\\vapain0-2c.png" },
          { name: "3 - Sometimes distracts me", color: "#9ACD32", image: "images\\details\\faces\\vapain3-4a.png" },
          { name: "4 - Distracts me", color: "#9ACD32", image: "images\\details\\faces\\vapain3-4b.png" },
          { name: "5 - Interrupts some activities", color: "Yellow", image: "images\\details\\faces\\vapain5-6a.png" },
          { name: "6 - Hard to ignore", color: "Yellow", image: "images\\details\\faces\\vapain5-6b.png" },
          { name: "7 - Stops daily activities", color: "#D2691E", image: "images\\details\\faces\\vapain7-8a.png" },
          { name: "8 - Awful, hard to do anything", color: "#D2691E", image: "images\\details\\faces\\vapain7-8b.png" },
          { name: "9 - Cannot bear", color: "Red", image: "images\\details\\faces\\vapain9-10a.png" },
          { name: "10 - As bad as can be", color: "Red", image: "images\\details\\faces\\vapain9-10b.png" }
        ]
    });


    var sizeDataSource = new kendo.data.DataSource({
        data: [
          { name: "Blueberry", image:"images\\details\\blueberry.png" },
          { name: "Cherry", image: "images\\details\\cherry.png" },
          { name: "Grape", image: "images\\details\\grape.png" },
          { name: "Strawberry", image: "images\\details\\strawberry.png" },
          { name: "Lemon", image: "images\\details\\lemon.png" },
          { name: "Orange", image: "images\\details\\orange.png" },
          { name: "Grapefruit", image: "images\\details\\grapefruit.png" },
          { name: "Cantaloupe", image: "images\\details\\cantaloupe.png" },
          { name: "Honeydew Melon", image: "images\\details\\honeydew.png" },
          { name: "Small Watermelon", image: "images\\details\\small-watermelon.png" },
          { name: "Large Watermelon", image: "images\\details\\large-watermelon.png" }
        ]
    });

    var howHurtDataSource = new kendo.data.DataSource({
        data: [
          { name: "None"},
          { name: "Burning" },
          { name: "Aching" },
          { name: "Stabbing" }
        ]
    });

    var depthDataSource = new kendo.data.DataSource({
        data: [
          { name: "Less than head of cotton swab", image: 'images\\details\\depth\\q-tip-0-sm.png'},
          { name: "Head of cotton swab", image: 'images\\details\\depth\\q-tip-1-sm.png' },
          { name: "Half of cotton swab", image: 'images\\details\\depth\\q-tip-2-sm.png' },
          { name: "2/3 of cotton swab", image: 'images\\details\\depth\\q-tip-3-sm.png' },
          { name: "Whole cotton swab", image: 'images\\details\\depth\\q-tip-5-sm.png' },
          { name: "Deeper than cotton swab", image: 'images\\details\\depth\\q-tip-6-sm.png' }
        ]
    });

    var drainingDataSource = new kendo.data.DataSource({
        data: [
          { name: "No" },
          { name: "Sometimes" },
          { name: "All the time" }
        ]
    });

    var drainAmountDataSource = new kendo.data.DataSource({
        data: [
          { name: "None -  Pressure ulcer and bandage dry" },
          { name: "Very little - Pressure ulcer moist, bandage mostly dry" },
          { name: "Small - Pressure ulcer very moist, part of bandage wet" },
          { name: "Medium - Pressure ulcer draining, drainage stays inside bandage" },
          { name: "Large - Bandage is leaking onto clothing or bed" }
        ]
    });

    var drainAppearanceDataSource = new kendo.data.DataSource({
        data: [
          { name: "None" },
          { name: "Thin, clear and runny like water" },
          { name: "Bloody, freshly bleeding" },
          { name: "Thin, pink and watery" },
          { name: "Thin, watery and cloudy and yellow" },
          { name: "Thick and tan, yellow, green, or brown" }
        ]
    });


    var photoDataSource = new kendo.data.DataSource({
        data: [
          { id: 1, name: "Photo 1", hasPhoto: 0, image: 'images\\learn\\camera-64x64.png', takenImage: "", date: "" },
          { id: 2, name: "Photo 2", hasPhoto: 0, image: 'images\\learn\\camera-64x64.png', takenImage: "", date: "" },
          { id: 3, name: "Photo 3", hasPhoto: 0, image: 'images\\learn\\camera-64x64.png', takenImage: "", date: "" }
        ],
        schema: {
            model: { id: "id" }
        }
    });



    var selectedString = "No Value Selected"
    //Type:  1 - Single select, 2- multi select, 3- slider, 4 - body, 5 - notes, 6 - photos
    var mainDataSource = new kendo.data.DataSource({
        data: [
          { questionId: 15, question: "Take up to 3 Photos", title:"Pictures", selected: selectedString, childData: photoDataSource, type:6},
          { questionId: 1, question: "Where is it?", title: "Location", shortTitle: "location", selected: selectedString, type: 4, instructions: "Tap the camera to take a picture of your pressure ulcer. You can take up to three pictures." },
          { questionId: 2, question: "How big is it?", title: "Size", shortTitle: "Size", selected: selectedString, childData: sizeDataSource, type: 1, instructions: "Pick the fruit that is about the size of the pressure ulcer." },
          { questionId: 3, question: "How does the skin look?", title: "Skin", shortTitle: "appearance", selected: selectedString, childData: skinDataSource, type: 2, instructions: "Pick one or more options to describe the pressure ulcer. " },
          { questionId: 4, question: "What color is it?", title: "Color", shortTitle: "color", selected: selectedString, childData: colorDataSource, type: 1, instructions: "Pick the color closest to the pressure ulcer." },
          { questionId: 5, question: "How does it smell?", title: "Smell", shortTitle: "smell", selected: selectedString, childData: smellDataSource, type: 1, instructions: "Pick one option that describes the pressure ulcer." },
          { questionId: 6, question: "What shape is it?", title: "Shape", shortTitle: "shape", selected: selectedString, childData: whatDataSource, type: 1, instructions: "Pick one option that describes the pressure ulcer." },
          { questionId: 7, question: "When does it hurt?", title: "Pain", shortTitle: "when", selected: selectedString, childData: whenDataSource, type: 1, instructions: "Pick one option that describes the pressure ulcer." },
          { questionId: 8, question: "How much does it hurt?", title: "Pain Level", shortTitle: "painLevel", selected: selectedString, childData: painLevelDataSource, type: 1, instructions: "Pick one option to describe how much pain the pressure ulcer is causing." },
          { questionId: 10, question: "How does it hurt?", title: "Pain Type", shortTitle: "painType", selected: selectedString, childData: howHurtDataSource, type: 1, instructions: "Pick one option that describes the type of pain." },
          { questionId: 9, question: "How deep is it?", title: "Depth", shortTitle: "Depth", selected: selectedString, childData: depthDataSource, type: 1, instructions: "Pick the option that is about the depth of the pressure ulcer." },
          { questionId: 11, question: "Is it draining?", title: "Drainage", shortTitle: "isDraining", selected: selectedString, childData: drainingDataSource, type: 1, instructions: "Pick one option that describes the pressure ulcer." },
          { questionId: 12, question: "How much is it draining?", title: "Drainage Amount", shortTitle: "DrainingQuality", selected: selectedString, childData: drainAmountDataSource, type: 1, instructions: "Pick one option that describes the pressure ulcer." },
          { questionId: 13, question: "What does the drainage look like?", title: "Drainage Type", shortTitle: "DrainingAppearance", selected: selectedString, childData: drainAppearanceDataSource, type: 1, instructions: "Pick one option that describes the pressure ulcer." },
          { questionId: 14, question: "Notes (optional)", title: "Notes", shortTitle: "Notes", selected: "", childData: null, type: 5, instructions: "If you want to add more information about your pressure ulcer, type it here." }
        ],
        schema: {
         model: { id: "questionId" }
        }
    });

    var mapLinksDataSource = new kendo.data.DataSource({
        data: [
          { code: "1f", map: "bodyMapFrontHead", image: "frontHeadImage" },
          { code: "1b", map: "bodyMapBackHead", image: "backHeadImage" },
          { code: "1l", map: "bodyMapLeftHead", image: "leftHeadImage" },
          { code: "1r", map: "bodyMapRightHead", image: "rightHeadImage" },


          { code: "m2f", map: "bodyMapBreastsMale", image: "maleBreastImage" },
          { code: "f2f", map: "bodyMapBreastsFemale", image: "femaleBreastImage" },
          { code: "m2b", map: "bodyMapShouldersMale", image: "maleShoulderImage" },
          { code: "f2b", map: "bodyMapShouldersFemale", image: "femaleShoulderImage" },
          { code: "m2r", map: "bodyMapRightElbowMale", image: "maleRightElbowImage" },
          { code: "f2r", map: "bodyMapRightElbowFemale", image: "femaleRightElbowImage" },
          { code: "m2l", map: "bodyMapLeftElbowMale", image: "maleLeftElbowImage" },
          { code: "f2l", map: "bodyMapLeftElbowFemale", image: "femaleLeftElbowImage" },

          { code: "m3f", map: "bodyMapFrontGroinMale", image: "maleFrontGroinImage" },
          { code: "f3f", map: "bodyMapFrontGroinFemale", image: "femaleFrontGroinImage" },
          { code: "m3b", map: "bodyMapButtocksMale", image: "maleButtocksImage" },
          { code: "f3b", map: "bodyMapButtocksFemale", image: "femaleButtocksImage" },
          { code: "m3r", map: "bodyMapRightHipMale", image: "maleRightHipImage" },
          { code: "f3r", map: "bodyMapRightHipFemale", image: "femaleRightHipImage" },
          { code: "m3l", map: "bodyMapLeftHipMale", image: "maleLeftHipImage" },
          { code: "f3l", map: "bodyMapLeftHipFemale", image: "femaleLeftHipImage" },

          { code: "m4f", map: "bodyMapKneecapMale", image: "maleKneecapImage" },
          { code: "f4f", map: "bodyMapKneecapFemale", image: "femaleKneecapImage" },
          { code: "m4b", map: "bodyMapCalfMale", image: "maleCalfImage" },
          { code: "f4b", map: "bodyMapCalfFemale", image: "femaleCalfImage" },
          { code: "m4r", map: "bodyMapRightBackKneeMale", image: "maleRightBackKneeImage" },
          { code: "f4r", map: "bodyMapRightBackKneeFemale", image: "femaleRightBackKneeImage" },
          { code: "m4l", map: "bodyMapLeftBackKneeMale", image: "maleLeftBackKneeImage" },
          { code: "f4l", map: "bodyMapLeftBackKneeFemale", image: "femaleLeftBackKneeImage" },

          { code: "5f", map: "bodyMapToes", image: "toesImage" },
          { code: "5b", map: "bodyMapBottomFeet", image: "bottomFeetImage" },
          { code: "5l", map: "bodyMapLeftAnkle", image: "leftAnkleImage" },
          { code: "5r", map: "bodyMapRightAnkle", image: "rightAnkleImage" }
        ]
    });

    var bodyTermsDataSource = new kendo.data.DataSource({
        data: [

          { commonName: "Mouth", code: "9", medicalName: ",mouth (9)" },
          { commonName: "Nose", code: "8", medicalName: "nose(8)" },
          { commonName: "Right Ear", code: "10", medicalName: "ear right (10)" },
          { commonName: "Left Ear", code: "11", medicalName: "ear left (11)" },
          { commonName: "Breasts", code: "12", medicalName: "breasts (12)" },
          { commonName: "Hipbone Front Right", code: "15", medicalName: "hipbone front right (15)" },
          { commonName: "Hipbone Front Left", code: "16", medicalName: "hipbone front left (16)" },
          { commonName: "Ankle Inside Left", code: "34li", medicalName: "ankle inside left (34li)" },
          { commonName: "Ankle Inside Right", code: "34ri", medicalName: "ankle inside right (34ri)" },
          { commonName: "Ankle Outside Left", code: "34lo", medicalName: "ankle outside left (34lo)" },
          { commonName: "Ankle Outside Right", code: "34ro", medicalName: "ankle outside right (34ro)" },
          { commonName: "Back of the Head", code: "20", medicalName: "back of head (occipital) (20)" },
          { commonName: "Left Buttock", code: "22", medicalName: "buttock left (22)" },
          { commonName: "Right Buttock", code: "21", medicalName: "buttock right (21)" },
          { commonName: "Sacral", code: "21sac", medicalName: "21sac-sacral" },
          { commonName: "Left Calf", code: "31", medicalName: "calf left (31)" },
          { commonName: "Right Calf", code: "32", medicalName: "calf right (32)" },
          { commonName: "Left Ear", code: "11", medicalName: "ear left (11)" },
          { commonName: "Right Ear", code: "10", medicalName: "ear right (10)" },
          { commonName: "Left Elbow", code: "30l", medicalName: "elbow left (30l)" },
          { commonName: "Right Elbow", code: "30r", medicalName: "elbow right (30r)" },
          { commonName: "Groin", code: "17", medicalName: "groin (17)" },
          { commonName: "Left Heel", code: "33l", medicalName: "heel left (33l)" },
          { commonName: "Right Heel", code: "33r", medicalName: "heel right (33r)" },
          { commonName: "Left Hipbone", code: "29l", medicalName: "hipbone left (ilium) (29l)" },
          { commonName: "Right Hipbone", code: "29r", medicalName: "hipbone right (ilium) (29r)" },
          { commonName: "Inside Left Knee", code: "19li", medicalName: "knee inside left (19li)" },
          { commonName: "Inside Right Knee", code: "18li", medicalName: "knee inside right (18li)" },
          { commonName: "Outside Left Knee", code: "19lo", medicalName: "knee outside left  (19lo)" },
          { commonName: "Outside Right Knee", code: "18lo", medicalName: "knee outside right (18lo)" },
          { commonName: "Left Kneecap", code: "19f", medicalName: "kneecap left (19f)" },
          { commonName: "Right Kneecap", code: "18f", medicalName: "kneecap right (18f)" },
          { commonName: "Left Shoulder Blade", code: "13b", medicalName: "shoulder blade left (13b)" },
          { commonName: "Right Shoulder Blade", code: "14b", medicalName: "shoulder blade right (14b)" },
          { commonName: "Front Left Shoulder", code: "13F", medicalName: "shoulder front left (13F)" },
          { commonName: "Front Right Shoulder", code: "14F", medicalName: "shoulder front right (14F)" },
          { commonName: "Left Shoulder Outside", code: "13lo", medicalName: "shoulder left (13lo)" },
          { commonName: "Right Shoulder Outside", code: "14ro", medicalName: "shoulder right (14ro)" },
          { commonName: "Left Toes", code: "24l", medicalName: "toes left (24l)" },
          { commonName: "Right Toes", code: "24r", medicalName: "toes right (24r)" },
          { commonName: "Upper Left Thigh", code: "28l", medicalName: "upper thigh left (outside of iscium/hip socket) (28l)" },
          { commonName: "Upper Right Thigh", code: "28r", medicalName: "upper thigh rightt (outside of iscium/hip socket) (28r)" },
          { commonName: "Sacrum", code: "21sac", medicalName: "sacrum (21sac)" },
          { commonName: "Cervical Spine", code: "35s", medicalName: "spine-servical (35s)" },
          { commonName: "Thoracic Spine", code: "36s", medicalName: "spine-thoracic (36s)" },
          { commonName: "Lumbar Spine", code: "37s", medicalName: "spine-lumbar (37s)" },
          { commonName: "Left Lower Leg", code: "38", medicalName: "left back soleus-back leg between calf and achilles (38)" },
          { commonName: "Right Lower Leg", code: "39", medicalName: "right back soleus-back leg between calf and achilles (39)" },

        ]
    });
