﻿

      var homeGridOriginal =[
            { "title": "Journal Entry", image: "images\\learn\\journal-02-64x64.png", url: "html/health/journal-home.html"},
            { "title": "Set Reminders", image: "images\\learn\\icon-clock-64x64.png", url: "html/reminders.html"},
            { "title": "Find Symptoms and Causes", image: "images\\learn\\find-search-clr-lg.png", url: "html/search.html" },
            { "title": "Ask My Medical Team", image: "images\\learn\\ask-doc5-64x64.png", url: "html/backpack/ask-medical-team.html" },
            { "title": "Add Shortcut 1", image: "images\\learn\\icon-settings-home-sm.png", url: "html/backpack/setup-ask-customize-home.html" },
            { "title": "Add Shortcut 2", image: "images\\learn\\icon-settings-home-sm.png", url: "html/backpack/setup-ask-customize-home.html" },
            { "title": "Add Shortcut 3", image: "images\\learn\\icon-settings-home-sm.png", url: "html/backpack/setup-ask-customize-home.html" },
            { "title": "Add Shortcut 4", image: "images\\learn\\icon-settings-home-sm.png", url: "html/backpack/setup-ask-customize-home.html" },
            { "title": "Add Shortcut 5", image: "images\\learn\\icon-settings-home-sm.png", url: "html/backpack/setup-ask-customize-home.html" }
        ];


var homeOptionGrid = new kendo.data.DataSource({
    data: [
     { id: 1, title: "Get More Protein", description: "Add more protein to your diet", selected: 0, image: "images\\learn\\icon-protein64x64.png", url: "html/nutrition/add-protein.html" },
     { id: 2, title: "Exercise in Wheelchair", description: "Exercises you can do in a wheelchair", selected: 0, image: "images\\learn\\wc-bble-basktbll-64x64.png", url: "html/exercise/ex-q-04.html" },
     { id: 3, title: "Exercise in Bed", description: "Exercises you can do in bed", selected: 0, image: "images\\learn\\bed-exercise-64x64.png", url: "html/exercise/ex-q-05.html" },
     { id: 4, title: "Exercise Walking", description: "Exercises you can do walking", selected: 0, image: "images\\learn\\bubble-man-walk-64x64.png", url: "html/exercise/ex-q-03.html" },
     { id: 5, title: "Take Vital Signs", description: "Learn how to take/record vital signs", selected: 0, image: "images\\learn\\vitals-64x64.png", url: "html/caregiver/cg-25.html" },
     { id: 6, title: "Taking Care of Myself", description: "Learn ways to cope and stay well", selected: 0, image: "images\\learn\\me-sm.png", url: "html/caregiver/cg-01.html" },
     { id: 7, title: "Portion Serving Size", description: "Learn about portions and serving sizes", selected: 0, image: "images\\learn\\portions-dkblue-sm.png", url: "html/nutrition/portions-and-servings.html" },
     { id: 8, title: "Plan Menus", description: "Sample menus", selected: 0,  image: "images\\nutrition\\menu-64x64.png", url: "html/nutrition/menu-plan.html" },
     { id: 9, title: "Food Groups", description: "Learn about food groups and nutrition", selected: 0, image: "images\\nutrition\\myplate-white-64x64.png", url: "html/nutrition/choose-my-plate.html" },
     { id: 10, title: "Wound Care", description: "Learn how to take care of a pressure ulcer", selected: 0, image: "images\\learn\\icon_wound_care_red.png", url: "html/prevention/wcare-01.html" },
     { id: 11, title: "Watch Video", description: " Learn to care for Veteran by watching a video", selected: 0, image: "images\\learn\\show-me-02-64x64.png", url: "html/backpack/tutorials.html" }
   
    ]
});

function getCurrentHomeGrid() {

    homeOptionGrid.read();

    homeGridCurrent = homeGridOriginal.slice(0);

    for (i = 0; i < 5; i++) {
        var itemNum = "HomeItem" + (i + 1).toString();
        var item = window.localStorage.getItem(itemNum);

        if (item) {
            var a = parseInt(item);
            //console.log(a);
            homeGridCurrent[4+i] = homeOptionGrid.at(a - 1);
        }
    }



    //then return the value
    return homeGridCurrent;
}


var videoDataSource = new kendo.data.DataSource({
    data: [
     { id: 10, title: "Use this App", description: "Learn to use this app", image: "images\\learn\\show-me-02-64x64.png", url: "html/backpack/video-player.html?id=10", filename: "media/about.mp4", runtime: "11:00", previewImage: "images\\learn\\show-me-02-64x64.png" },
     { id: 11, title: "Make a Journal Entry", description: "Learn to make a new journal entry", image: "images\\learn\\show-me-02-64x64.png", url: "html/backpack/video-player.html?id=11", filename: "media/journal.mp4", runtime: "03:25", previewImage: "images\\learn\\show-me-02-64x64.png" },
     { id: 1, title: "Move from Bed to Wheelchair (1)", description: "Learn to move Veteran into wheelchair from adjustable or hospital bed", image: "images\\icons\\videos\\icon-video01.png", url: "html/backpack/video-player.html?id=1", filename: "media/Video1.mp4", runtime: "02:56", previewImage: "images\\icons\\videos\\icon-video01.png" },
     { id: 2, title: "Move from Bed to Wheelchair (2)", description: "Learn to move Veteran into wheelchair from standard bed", image: "images\\icons\\videos\\icon-video02.png", url: "html/backpack/video-player.html?id=2", filename: "media/Video 2.mp4", runtime: "02:47", previewImage: "images\\icons\\videos\\icon-video02.png" },
     { id: 3, title: "Move from Wheelchair to Bed", description: "Learn to move Veteran into bed from wheelchair", image: "images\\icons\\videos\\icon-video03.png", url: "html/backpack/video-player.html?id=3", filename: "media/Video 3.mp4", runtime: "02:45", previewImage: "images\\icons\\videos\\icon-video03.png" },
     { id: 4, title: "Move Using Transfer Board", description: "Learn to move Veteran from wheelchair into bed using transfer board", image: "images\\icons\\videos\\icon-video04.png", url: "html/backpack/video-player.html?id=4", filename: "media/Video 4.mp4", runtime: "02:41", previewImage: "images\\icons\\videos\\icon-video04.png" },
     { id: 5, title: "Make and Use a Draw Sheet", description: "Learn to fold and use a draw sheet to reposition Veteran", image: "images\\icons\\videos\\icon-video05.png", url: "html/backpack/video-player.html?id=5", filename: "media/Video 5.mp4", runtime: "01:19", previewImage: "images\\icons\\videos\\icon-video05.png" },
     { id: 6, title: "Reposition in Bed", description: "Learn to reposition Veteran in hospital bed", image: "images\\icons\\videos\\icon-video06.png", url: "html/backpack/video-player.html?id=6", filename: "media/Video 6.mp4", runtime: "01:13", previewImage: "images\\icons\\videos\\icon-video06.png" },
     { id: 7, title: "Reposition in Wheelchair", description: "Learn to reposition Veteran in wheelchair", image: "images\\icons\\videos\\icon-video07.png", url: "html/backpack/video-player.html?id=7", filename: "media/Video 7.mp4", runtime: "01:02", previewImage: "images\\icons\\videos\\icon-video07.png" },
     { id: 8, title: "Reposition Self in Wheelchair", description: "Learn how Veterans can reposition themselves (requires use of legs)", image: "images\\icons\\videos\\icon-video08.png", url: "html/backpack/video-player.html?id=8", filename: "media/Video 8.mp4", runtime: "00:57", previewImage: "images\\icons\\videos\\icon-video08.png" },
     { id: 9, title: "Check Skin Turgor", description: "Learn how to check skin for severe dehydration", image: "images\\icons\\videos\\icon-video09.png", url: "html/backpack/video-player.html?id=11", filename: "media/Video 9.mp4", runtime: "00:41", previewImage: "images\\icons\\videos\\icon-video09.png" },
     { id: 12, title: "Check for Blanching", description: "Learn how to see if skin changes color correctly", image: "images\\icons\\videos\\icon-video10.png", url: "html/backpack/video-player.html?id=12", filename: "media/Video 10.mp4", runtime: "00:51", previewImage: "images\\icons\\videos\\icon-video10.png" },
     { id: 13, title: "Care for Heels", description: "Learn to prevent pressure ulcers on heels", image: "images\\icons\\videos\\icon-video11.png", url: "html/backpack/video-player.html?id=13", filename: "media/Video 11.mp4", runtime: "00:55", previewImage: "images\\icons\\videos\\icon-video11.png" }
    ],
     schema: {
        model: { id: "id" }
    }
});

//Contacts

var groupedContactData = new kendo.data.DataSource({
    data: [],
    group: { field: "group" },
    schema: {
        model: { id: "id" }
    }
});

function loadGroupedContactData() {

    var savedData = window.localStorage.getItem("SavedContactsData");
    if (savedData && savedData.length > 10) {

        //var decrypted = CryptoJS.AES.decrypt(savedData, getKey());
        //decrypted = decrypted.toString(CryptoJS.enc.Utf8);
        //savedData = decrypted;

        var jsonObject = jQuery.parseJSON(savedData);

        //console.log("Saved: " + savedData);
        console.log(jsonObject);

        groupedContactData = kendo.data.DataSource.create({
            data: jsonObject,
            group: "group",
            schema: {
                model: { id: "id" }
            }
        });

    }
}

function getPrimaryCareObject() {
    loadGroupedContactData();

    console.log("loading Primary care object");
    if (groupedContactData) {

        groupedContactData.filter({ field: "group", operator: "startswith", value: "Primary Care Physician" });
        var view = groupedContactData.view();
        var doctorObject = view[0];

        //console.log(view.length);
        //console.log(view[0].firstName);

        groupedContactData.filter({});

        return doctorObject;

    }

    return null;
}


//Checklist items

var questionsRootDataSource = new kendo.data.DataSource({
    data: [
          { name: "When are you coming back?", selected: 0, questionId: 1, parentId: 1 },
          { name: "What do I do if my supplies run out?", selected: 0, questionId: 2, parentId: 1 },
          { name: "How often do I need to change the dressing?", selected: 0, questionId: 3, parentId: 1 },
          { name: "How do I change the dressing?", selected: 0, questionId: 4, parentId: 1 },
          { name: "What do I do if it gets worse?", selected: 0, questionId: 5, parentId: 1 },
          { name: "Am I doing all the right things?", selected: 0, questionId: 6, parentId: 2 },
          { name: "What else am I entitled to?", selected: 0, questionId: 7, parentId: 2 },
          { name: "Is the pressure ulcer healing?", selected: 0, questionId: 8, parentId: 2 },
          { name: "What else can I do?", selected: 0, questionId: 9, parentId: 2 },
          { name: "How is my progress?", selected: 0, questionId: 10, parentId: 2 },
          { name: "How does it look to you?", selected: 0, questionId: 11, parentId: 2 },
          { name: "Should I limit my sitting?", selected: 0, questionId: 12, parentId: 2 },
          { name: "What day-to-day activities should I change to get better?", selected: 0, questionId: 13, parentId: 2 },
          { name: "Does my wheelchair need to be re-evaluated?", selected: 0, questionId: 14, parentId: 2 },
          { name: "What might have caused this?", selected: 0, questionId: 15, parentId: 2 },
          { name: "What is this called?", selected: 0, questionId: 16, parentId: 2 },
          { name: "Is this likely to go away on its own?", selected: 0, questionId: 17, parentId: 2 },
          { name: "Is the pain going to diminish or go away?", selected: 0, questionId: 18, parentId: 2 },
          { name: "How will you treat this?", selected: 0, questionId: 19, parentId: 2 },
          { name: "What are some other ways to treat this?", selected: 0, questionId: 20, parentId: 2 },
          { name: "What are the risks of this treatment?", selected: 0, questionId: 21, parentId: 2 },
          { name: "What is the future of this with/without the recommended treatment?", selected: 0, questionId: 22, parentId: 2 },
          { name: "How long will the treatment take?", selected: 0, questionId: 23, parentId: 2 },
          { name: "Will I have to go to the hospital?", selected: 0, questionId: 24, parentId: 2 },
          { name: "How long will it take me to get better?", selected: 0, questionId: 25, parentId: 2 },
          { name: "How will this change what I can do every day?", selected: 0, questionId: 26, parentId: 2 },
          { name: "How can I prevent this in the future?", selected: 0, questionId: 27, parentId: 2 },
          { name: "When should I be worried?", selected: 0, questionId: 28, parentId: 2 },
          { name: "Do I need this test or procedure to confirm or disprove a diagnosis?", selected: 0, questionId: 29, parentId: 3 },
          { name: "Will the test results change the way my condition is treated?", selected: 0, questionId: 30, parentId: 3 },
          { name: "What are the risks involved?", selected: 0, questionId: 31, parentId: 3 },
          { name: "What happens if I refuse the test?", selected: 0, questionId: 32, parentId: 3 },
          { name: "How much does the test cost and will my insurance pay for it?", selected: 0, questionId: 33, parentId: 3 },
          { name: "Will the test results change any of my medications?", selected: 0, questionId: 34, parentId: 3 },
          { name: "What are the chances the test results could be wrong?", selected: 0, questionId: 35, parentId: 3 },
          { name: "Do I have to do anything to get ready for the test?", selected: 0, questionId: 36, parentId: 3 },
          { name: "How can my caregiver help me get ready for this test?", selected: 0, questionId: 37, parentId: 3 },
          { name: "How will the test make me feel?  Will it be painful?", selected: 0, questionId: 38, parentId: 3 },
          { name: "Will I need help getting home afterward?", selected: 0, questionId: 39, parentId: 3 },
          { name: "Who will review the test results?", selected: 0, questionId: 40, parentId: 3 },
          { name: "Will someone call with the test results or should I phone for them?", selected: 0, questionId: 41, parentId: 3 },
          { name: "Can test results be sent directly to me or to my Caregiver?", selected: 0, questionId: 42, parentId: 3 },
          { name: "What days/hours is the office open?", selected: 0, questionId: 43, parentId: 4 },
          { name: "Who should I call first in an emergency?", selected: 0, questionId: 44, parentId: 4 },
          { name: "How are medical emergencies handled?", selected: 0, questionId: 45, parentId: 4 },
          { name: "When is the best time to reach the doctor by phone, fax or email?", selected: 0, questionId: 46, parentId: 4 },
          { name: "How does the doctor like to be contacted?", selected: 0, questionId: 47, parentId: 4 },
          { name: "Who can answer questions if the doctor is not available?", selected: 0, questionId: 48, parentId: 4 },
          { name: "Who can I call after hours or when the doctor is away?", selected: 0, questionId: 49, parentId: 4 },
          { name: "What costs are not covered by VA health benefits?", selected: 0, questionId: 50, parentId: 5 },
          { name: "About how much will I have to pay in the long run for treatment?", selected: 0, questionId: 51, parentId: 5 },
          { name: "What private insurance plans do you accept?", selected: 0, questionId: 52, parentId: 5 },
          { name: "Where will I go after I'm discharged?", selected: 0, questionId: 53, parentId: 6 },
          { name: "Who will provide additional home health care if I need it?", selected: 0, questionId: 54, parentId: 6 },
          { name: "Do I need any home health equipment? What kind?", selected: 0, questionId: 55, parentId: 6 },
          { name: "Do I need physical and/or occupational therapy visits?", selected: 0, questionId: 56, parentId: 6 },
          { name: "What other services will I need and for how long?", selected: 0, questionId: 57, parentId: 6 },
          { name: "How will the added expenses be paid for?", selected: 0, questionId: 58, parentId: 6 },
          { name: "What paperwork do I have to do to get these services lined up?", selected: 0, questionId: 59, parentId: 6 },
          { name: "What new skills do I need to learn?", selected: 0, questionId: 60, parentId: 6 },
          { name: "Who will teach me these skills?", selected: 0, questionId: 61, parentId: 6 }
    ],
    schema: {
        model: { id: "questionId" }
    }

});

function getSavedQuestionArray() {

    var returnArray = new Array();

    questionsRootDataSource.filter({ field: "selected", operator: "equals", value: 1 });
    var view = questionsRootDataSource.view();
    for (var x = 0; x < view.length; x++) {
         returnArray.push(view[x].name);
    }

    //clear the filter
    questionsRootDataSource.filter({});

    return returnArray;
}


//Medicine Reminders

var medicinesDataSource = new kendo.data.DataSource({
    data: [
          { id: 0, type: 1, name: "Add Medication Reminder", description: "Set a reminders to take medications", image: "images\\learn\\rx-64x64.png" }
    ],
    schema: {
        model: { id: "id" }
    }
});

function loadMedReminderData() {

    var savedData = window.localStorage.getItem("SavedMedReminderData");

   
    if (savedData && savedData.length > 10) {
        var jsonObject = jQuery.parseJSON(savedData);

        //console.log("Saved: " + savedData);
        //console.log(jsonObject);

        medicinesDataSource = kendo.data.DataSource.create({
            data: jsonObject,
            schema: {
                model: { id: "id" }
            }
        });

    }
}

function saveMedReminderData() {

    var stringData = kendo.stringify(medicinesDataSource.data());
    window.localStorage.setItem("SavedMedReminderData", stringData);
}

var reminderDataSource = new kendo.data.DataSource({
    data: [
      { id: 1, on: 0, type: 3, name: "Turn Off All Reminders", description: "Turn off all reminders shuts off any reminders you set in this App. Use this if you are at an appointment or do not want to be disturbed.", image: "images\\learn\\reminder-off-64x64.png" },
      { id: 2, on: 0, type: 2, startTime: "21:30", endTime: "07:30", napOff: 0, frequency: 60, name: "Change Positions", description: "If you are in a wheelchair you should change positions every 15 minutes. If you are bed-bound, you should change positions every 30 minutes.", image: "images\\learn\\reposition-sm.png", reminderText: "It is time to change positions." },
      { id: 3, on: 0, type: 2, startTime: "21:30", endTime: "07:30", napOff: 0, frequency: 60, name: "Eat a Snack", description: "If you are on a high-calorie, high-protein diet, your medical team may want you to eat a snack pretty often.  Set your reminder to snack based on what they tell you.", image: "images\\learn\\salad-64x64.png", reminderText: "It is time to eat a snack." },
      //{ id: 4, on: 0, type: 1, startTime: "21:30", endTime: "07:30", napOff: 0, numTimes: 1, per: 1, fStart: "12:00", name: "Changing Bandage", description: "Carefully follow your medical team's instructions for cleaning your pressure ulcer and changing your bandage." },
      //{ id: 5, on: 0, type: 4, startTime: "21:30", name: "Add Medication Reminder", description: "Set a reminders to take medications", datetime: "", typeAppt: "Primary Care Physician" }
      { id: 5, on: 0, type: 5, name: "Medication Reminders", description: "Set a reminders to take medications", image: "images\\learn\\rx-64x64.png" }
      //,{ id: 6, on: 0, type: 1, startTime: "21:30", endTime: "07:30", napOff: 0, numTimes: 1, per: 1, fStart: "12:00", name: "Exercise", description: "Carefully follow your medical team's instructions for exercising and only do the exercises your medical team tells you to." }
    ],
    schema: {
        model: { id: "id" }
    }
});

function loadReminderData() {

    var savedData = window.localStorage.getItem("SavedReminderData");


    if (savedData && savedData.length > 10) {
        var jsonObject = jQuery.parseJSON(savedData);

        //console.log("Saved: " + savedData);
        //console.log(jsonObject);

        reminderDataSource = kendo.data.DataSource.create({
            data: jsonObject,
            schema: {
                model: { id: "id" }
            }
        });

    }
}

function saveReminderData() {

    var stringData = kendo.stringify(reminderDataSource.data());
    window.localStorage.setItem("SavedReminderData", stringData);
}

function saveJSONDataWithKey(data, key) {
    var stringData = (data?JSON.stringify(data):"");
    window.localStorage.setItem(key, stringData);
}
function loadJSONDataFromKeyToArray(key) {

    var savedData = window.localStorage.getItem(key);


    if (savedData && savedData.length > 4) {
        return jQuery.parseJSON(savedData);
    }

    return null;
    
}



//Tablet data

var tabletDataSource = new kendo.data.DataSource({
    data: [
    { id: 2, hasContent: false, parentID: 0, pageTitle: "Learn", name: "Pressure Ulcers", description: "Learn about what they are and how to care for them", image: "images\\learn\\icon-health64x64.png", url: "html/prevention/pv-home.html" },
    { id: 3, hasContent: true, parentID: 2, pageTitle: "Definition", name: "What is a pressure ulcer?", image: "images\\learn\\icon_health_info_red.png", url: "html/prevention/pup-00.html" },
    { id: 4, hasContent: true, parentID: 2, pageTitle: "Risk", name: "Who's at risk?", image: "images\\learn\\who-risk-sm.png", url: "html/prevention/pup-01-a.html" },
    { id: 5, hasContent: true, parentID: 2, pageTitle: "Where", name: "Where do they happen?", image: "images\\learn\\here-64x64.png", url: "html/prevention/pup-01-b.html" },
    { id: 6, hasContent: true, parentID: 2, pageTitle: "When", name: "When will it heal?", image: "images\\learn\\when-heal-sm.png", url: "html/prevention/pup-01-c.html" },
    { id: 7, hasContent: true, parentID: 2, pageTitle: "Stages", name: "What are the stages?", image: "images\\learn\\icon-stages-64x64.png", url: "html/prevention/pup-01-d.html" },
    { id: 8, hasContent: true, parentID: 2, pageTitle: "Symptoms", name: "Do I have one?", image: "images\\learn\\do-i-sm.png", url: "html/prevention/pup-02.html" },
    { id: 9, hasContent: true, parentID: 2, pageTitle: "Repositioning", name: "Why reposition?", image: "images\\learn\\reposition-sm.png", url: "html/prevention/pup-03.html" },
    { id: 10, hasContent: true, parentID: 2, pageTitle: "Protection", name: "How do I protect it?", image: "images\\learn\\icon-umbrella-64x64.png", url: "html/prevention/pup-04.html" },
    { id: 11, hasContent: true, parentID: 2, pageTitle: "Skin Care", name: "What about skin care?", image: "images\\learn\\lotion-sm.png", url: "html/prevention/pup-05.html" },
    { id: 12, hasContent: true, parentID: 2, pageTitle: "Incontinence", name: "How do I handle incontinence?", image: "images\\learn\\prevention_icon_incontinence-64x64.png", url: "html/prevention/pup-06.html" },
    { id: 13, hasContent: true, parentID: 2, pageTitle: "Check Skin", name: "How do I check the skin?", image: "images\\learn\\binoculars-64x64.png", url: "html/prevention/pup-07.html" },
    { id: 14, hasContent: true, parentID: 2, pageTitle: "Nutrition Importance", name: "Why is nutrition important?", image: "images\\learn\\nutrition_icon_menu.png", url: "html/prevention/pup-08.html" },
    { id: 48, hasContent: true, parentID: 14, pageTitle: "Nutrition", name: "What does nutrition have to do with my pressure ulcer?", url: "html/nutrition/nt-home.html" },
    { id: 15, hasContent: true, parentID: 2, pageTitle: "Exercise Helps", name: "How does exercise help?", image: "images\\learn\\stretching-64x64.png", url: "html/prevention/pup-09.html" },
    { id: 49, hasContent: false, parentID: 15, pageTitle: "Exercise", name: "Exercise", url: "html/exercise/ex-home.html" },
    { id: 16, hasContent: true, parentID: 2, pageTitle: "Care", name: "How do I take care of it?", image: "images\\learn\\icon_wound_care_red.png", url: "html/prevention/wcare-01.html" },
    { id: 17, hasContent: true, parentID: 2, pageTitle: "Infections", name: "What are infections?", image: "images\\learn\\biohaz-64x64.png", url: "html/prevention/wcare-02.html" },
    { id: 51, hasContent: true, parentID: 17, pageTitle: "Barriers", name: "Barriers That Prevent Infection", url: "html/prevention/wcare-03.html" },
    { id: 18, hasContent: false, parentID: 0, pageTitle: "Nutrition", name: "Nutrition", description: "Learn how it helps pressure ulcers heal", image: "images\\learn\\nutrition_icon_menu.png", url: "html/nutrition/nt-home.html" },
    { id: 19, hasContent: true, parentID: 18, pageTitle: "Nutrition", name: "What does nutrition have to do with my pressure ulcer?", image: "images\\learn\\nutrition_icon_menu.png", url: "html/nutrition/nt-01.html" },
    { id: 20, hasContent: true, parentID: 18, pageTitle: "Dietitian", name: "Should I see a dietician?", image: "images\\learn\\nutritionist-64x64.png", url: "html/nutrition/nt-02.html" },
    { id: 21, hasContent: true, parentID: 18, pageTitle: "High Protein-Calories", name: "What if a high-protein and high-calorie diet is recommended for me?", image: "images\\learn\\icon-protein64x64.png", url: "html/nutrition/nt-03.html" },
    { id: 52, hasContent: true, parentID: 21, pageTitle: "High Protein-Calories", name: "Add Protein", image: "images\\learn\\protein-jar-sm.png", url: "html/nutrition/add-protein.html" },
    { id: 53, hasContent: true, parentID: 52, pageTitle: "Add Protein", name: "Everyday Meals", image: "images\\learn\\plate-dinner-64x64.png", url: "html/nutrition/add-protein-meats.html" },
    { id: 54, hasContent: true, parentID: 52, pageTitle: "Add Protein", name: "Drink Recipes", image: "images\\learn\\delish-drinks-64x64.png", url: "html/nutrition/add-protein-drinks.html" },
    { id: 55, hasContent: true, parentID: 21, pageTitle: "High Protein-Calories", name: "How do I know how much protein and calories are in the food I make?", image: "images\\learn\\food-scale-sm.png", url: "html/nutrition/protein-calorie-counts.html" },
    { id: 56, hasContent: true, parentID: 21, pageTitle: "High Protein-Calories", name: "What are some cheap sources of protein?", image: "images\\learn\\icon-pig-64x64.png", url: "html/nutrition/ap-10-cheap.html" },
    { id: 22, hasContent: true, parentID: 18, pageTitle: "Guidelines", name: "What are the general guidelines for nutrition?", image: "images\\learn\\myplate-white-64x64.png", url: "html/nutrition/nt-04.html" },
    { id: 23, hasContent: false, parentID: 0, pageTitle: "Exercise", name: "Exercise", description: "Learn how it prevents pressure ulcers and see simple exercises", image: "images\\learn\\stretching-64x64.png", url: "html/exercise/ex-home.html" },
    { id: 24, hasContent: true, parentID: 23, pageTitle: "Importance", name: "What does exercise have to do with my pressure ulcer?", image: "images\\learn\\stretching-64x64.png", url: "html/exercise/ex-q-01.html" },
    { id: 25, hasContent: true, parentID: 23, pageTitle: "Physical Therapist", name: "Should I see a physical therapist?", image: "images\\learn\\therapist-64x64.png", url: "html/exercise/ex-q-00a.html" },
    { id: 26, hasContent: true, parentID: 23, pageTitle: "Getting Started", name: "How can I get started?", image: "images\\learn\\bbleman-start-64x64.png", url: "html/exercise/ex-q-02.html" },
    { id: 57, hasContent: true, parentID: 26, pageTitle: "I can walk", name: "I can walk", image: "images\\learn\\bubble-man-walk-64x64.png", url: "html/exercise/ex-q-03.html" },
    { id: 58, hasContent: true, parentID: 26, pageTitle: "I'm in a Wheelchair", name: "I'm in a wheelchair", image: "images\\learn\\bubble-man-wc-64x64.png", url: "html/exercise/ex-q-04.html" },
    { id: 60, hasContent: true, parentID: 58, pageTitle: "Neck", name: "Neck", url: "html/exercise/ex-05.html" },
    { id: 61, hasContent: true, parentID: 58, pageTitle: "Arms-1", name: "Arms-1", url: "html/exercise/ex-06.html" },
    { id: 62, hasContent: true, parentID: 58, pageTitle: "Arms-2", name: "Arms-2", url: "html/exercise/ex-q-04-wc-01.html" },
    { id: 63, hasContent: true, parentID: 58, pageTitle: "Arms-3", name: "Arms-3", url: "html/exercise/ex-q-04-wc-02.html" },
    { id: 64, hasContent: true, parentID: 58, pageTitle: "Arms-4", name: "Arms-4", url: "html/exercise/ex-q-04-wc-05.html" },
    { id: 65, hasContent: true, parentID: 58, pageTitle: "Arms-5", name: "Arms-5", url: "html/exercise/ex-q-04-wc-06.html" },
    { id: 66, hasContent: true, parentID: 58, pageTitle: "Arms-6", name: "Arms-6", url: "html/exercise/ex-q-04-wc-07.html" },
    { id: 67, hasContent: true, parentID: 58, pageTitle: "Arms-7", name: "Arms-7", url: "html/exercise/ex-q-04-wc-11.html" },
    { id: 68, hasContent: true, parentID: 58, pageTitle: "Arms-8", name: "Arms-8", url: "html/exercise/ex-q-04-wc-10.html" },
    { id: 69, hasContent: true, parentID: 58, pageTitle: "Hand-1", name: "Hand-1", url: "html/exercise/ex-01.html" },
    { id: 70, hasContent: true, parentID: 58, pageTitle: "Hand-2", name: "Hand-2", url: "html/exercise/ex-02.html" },
    { id: 71, hasContent: true, parentID: 58, pageTitle: "Hand 3", name: "Hand 3", url: "html/exercise/ex-03.html" },
    { id: 72, hasContent: true, parentID: 58, pageTitle: "Hand-4", name: "Hand-4", url: "html/exercise/ex-04.html" },
    { id: 73, hasContent: true, parentID: 58, pageTitle: "Core-1", name: "Core-1", url: "html/exercise/ex-q-04-wc-03.html" },
    { id: 74, hasContent: true, parentID: 58, pageTitle: "Core-2", name: "Core-2", url: "html/exercise/ex-q-04-wc-04.html" },
    { id: 75, hasContent: true, parentID: 58, pageTitle: "Core-3", name: "Core-3", url: "html/exercise/ex-q-04-wc-08.html" },
    { id: 76, hasContent: true, parentID: 58, pageTitle: "Core-4", name: "Core-4", url: "html/exercise/ex-q-04-wc-13.html" },
    { id: 77, hasContent: true, parentID: 58, pageTitle: "Buttocks", name: "Buttocks", url: "html/exercise/ex-q-04-wc-14.html" },
    { id: 78, hasContent: true, parentID: 58, pageTitle: "Legs-1", name: "Legs-1", url: "html/exercise/ex-09.html" },
    { id: 79, hasContent: true, parentID: 58, pageTitle: "Legs-2", name: "Legs-2", url: "html/exercise/ex-10.html" },
    { id: 80, hasContent: true, parentID: 58, pageTitle: "Legs-3", name: "Legs-3", url: "html/exercise/ex-11.html" },
    { id: 81, hasContent: true, parentID: 58, pageTitle: "Legs-4", name: "Legs-4", url: "html/exercise/ex-12.html" },
    { id: 82, hasContent: true, parentID: 58, pageTitle: "Legs-5", name: "Legs-5", url: "html/exercise/ex-q-04-wc-09.html" },
    { id: 83, hasContent: true, parentID: 58, pageTitle: "Feet-1", name: "Feet-1", url: "html/exercise/ex-07.html" },
    { id: 84, hasContent: true, parentID: 58, pageTitle: "Feet-2", name: "Feet-2", url: "html/exercise/ex-08.html" },
    { id: 85, hasContent: true, parentID: 58, pageTitle: "Wheelchair Sports", name: "Wheelchair Sports", url: "html/exercise/ex-q-04-wc-12.html" },
    { id: 59, hasContent: true, parentID: 26, pageTitle: "I am bedbound", name: "I am bedbound", image: "images\\learn\\bubble-man-bed-64x64.png", url: "html/exercise/ex-q-05.html" },
    { id: 86, hasContent: true, parentID: 59, pageTitle: "Neck", name: "Ncek", url: "html/exercise/ex-05.html" },
    { id: 87, hasContent: true, parentID: 59, pageTitle: "Arms-1", name: "Arms-1", url: "html/exercise/ex-q-05-bed-01.html" },
    { id: 88, hasContent: true, parentID: 59, pageTitle: "Hand-1", name: "Hand-1", url: "html/exercise/ex-01.html" },
    { id: 89, hasContent: true, parentID: 59, pageTitle: "Hand-2", name: "Hand-2", url: "html/exercise/ex-02.html" },
    { id: 90, hasContent: true, parentID: 59, pageTitle: "Hand-3", name: "Hand-3", url: "html/exercise/ex-03.html" },
    { id: 91, hasContent: true, parentID: 59, pageTitle: "Hand-4", name: "Hand-4", url: "html/exercise/ex-04.html" },
    { id: 92, hasContent: true, parentID: 59, pageTitle: "Core-1", name: "Core-1", url: "html/exercise/ex-q-05-bed-03.html" },
    { id: 93, hasContent: true, parentID: 59, pageTitle: "Core-2", name: "Core-2", url: "html/exercise/ex-q-05-bed-06.html" },
    { id: 94, hasContent: true, parentID: 59, pageTitle: "Buttocks", name: "Buttocks", url: "html/exercise/ex-q-05-bed-07.html" },
    { id: 95, hasContent: true, parentID: 59, pageTitle: "Legs-1", name: "Legs-1", url: "html/exercise/ex-q-05-bed-02.html" },
    { id: 96, hasContent: true, parentID: 59, pageTitle: "Legs-2", name: "Legs-2", url: "html/exercise/ex-q-05-bed-05.html" },
    { id: 97, hasContent: true, parentID: 59, pageTitle: "Legs-4", name: "Legs-4", url: "html/exercise/ex-q-05-bed-09.html" },
    { id: 98, hasContent: true, parentID: 59, pageTitle: "Feet-1", name: "Feet-1", url: "html/exercise/ex-07.html" },
    { id: 99, hasContent: true, parentID: 59, pageTitle: "Feet-2", name: "Feet-2", url: "html/exercise/ex-q-05-bed-04.html" },
    { id: 100, hasContent: true, parentID: 59, pageTitle: "Feet-3", name: "Feet-3", url: "html/exercise/ex-q-05-bed-08.html" },
    { id: 27, hasContent: true, parentID: 23, pageTitle: "Weights", name: "What can I use as weights?", image: "images\\learn\\icon-weights.png", url: "html/exercise/ex-q-06.html" },
    { id: 28, hasContent: false, parentID: 0, pageTitle: "Medicines", name: "Medicines", description: "Learn ways to organize and keep track of medicines", image: "images\\learn\\rx-64x64.png", url: "html/caregiver/medicines.html" },
    { id: 29, hasContent: true, parentID: 28, pageTitle: "Medicines", name: "Managing Medicines", image: "images\\learn\\rx-64x64.png", url: "html/caregiver/cg-22.html" },
    { id: 30, hasContent: true, parentID: 28, pageTitle: "Narcotics", name: "About Narcotic Pain Medicines", image: "images\\learn\\rx-bottles-64x64.png", url: "html/caregiver/cg-31.html" },
    { id: 31, hasContent: true, parentID: 0, pageTitle: "Pain Management", name: "Pain", description: "Learn about pain types and ways to manage pain", image: "images\\learn\\bbleman-hurt-leg-64x64.png", url: "html/caregiver/cg-23.html" },
    { id: 101, hasContent: true, parentID: 31, pageTitle: "Narcotics", name: "About Narcotic Pain Medicines", image: "images\\learn\\rx-bottles-64x64.png", url: "html/caregiver/cg-31.html" },
    { id: 32, hasContent: true, parentID: 0, pageTitle: "Vital Signs", name: "Vital Signs", description: "Learn what they are and how to take them", image: "images\\learn\\vitals-64x64.png", url: "html/caregiver/cg-25.html" },
    { id: 33, hasContent: false, parentID: 0, pageTitle: "Home Safety", name: "Home Safety", description: "Learn how to make your home a safer place", image: "images\\learn\\fall-dwn-stairs-64x64.png", url: "html/caregiver/home-safety.html" },
    { id: 34, hasContent: true, parentID: 33, pageTitle: "Home Safety", name: "How can I make the home safe?", image: "images\\learn\\fall-dwn-stairs-64x64.png", url: "html/caregiver/cg-30.html" },
    { id: 35, hasContent: true, parentID: 33, pageTitle: "Emergency Prep", name: "What if there's an emergency?", image: "images\\learn\\fireman-64x64.png", url: "html/caregiver/cg-30a.html" },
    { id: 36, hasContent: true, parentID: 33, pageTitle: "Protect Back", name: "How can I protect my back?", image: "images\\learn\\lifting-box-64x64.png", url: "html/caregiver/cg-10.html" },
    { id: 102, hasContent: true, parentID: 36, pageTitle: "Planning", name: "Planning the Lift", url: "html/caregiver/cg-11.html" },
    { id: 103, hasContent: true, parentID: 36, pageTitle: "Moving", name: "Moving the Veteran", url: "html/caregiver/cg-12.html" },
    { id: 37, hasContent: false, parentID: 0, pageTitle: "Caregiver Tips", name: "Caregiver Tips", description: "Learn about benefits and taking care of a Veteran", image: "images\\learn\\cg-vet-64x64.png", url: "html/caregiver/caregiver-tips.html" },
    { id: 104, hasContent: false, parentID: 37, pageTitle: "Myself", name: "Taking Care of Myself", image: "images\\learn\\me-sm.png", url: "html/caregiver/cg-01.html" },
    { id: 105, hasContent: true, parentID: 104, pageTitle: "Ask for Help", name: "Asking for Help", image: "images\\learn\\bbleman-sign-help-64x64.png", url: "html/caregiver/cg-05.html" },
    { id: 106, hasContent: true, parentID: 104, pageTitle: "Coping", name: "Coping", image: "images\\learn\\kumbaya-64x64.png", url: "html/caregiver/coping.html" },
    { id: 107, hasContent: true, parentID: 106, pageTitle: "Relaxing", name: "Relaxing", image: "images\\learn\\kumbaya-64x64.png", url: "html/caregiver/coping.html" },
    { id: 108, hasContent: true, parentID: 106, pageTitle: "Family", name: "Family", image: "images\\learn\\family-64x64.png", url: "html/caregiver/cg-16.html" },
    { id: 109, hasContent: true, parentID: 106, pageTitle: "Journaling", name: "Journaling", image: "images\\learn\\journal-01-64x64.png", url: "html/caregiver/cg-17.html" },
    { id: 110, hasContent: true, parentID: 104, pageTitle: "Eating Right", name: "Eating Right", image: "images\\learn\\salad-64x64.png", url: "html/caregiver/cg-06.html" },
    { id: 111, hasContent: true, parentID: 110, pageTitle: "Food Groups", name: "Food Groups", image: "images\\nutrition\\myplate-white-64x64.png", url: "html/nutrition/choose-my-plate.html" },
    { id: 112, hasContent: true, parentID: 110, pageTitle: "Tips", name: "Tips for Eating Right", image: "images\\learn\\plate-dinner-64x64.png", url: "html/caregiver/cg-06a.html" },
    { id: 113, hasContent: true, parentID: 110, pageTitle: "Cooking Methods", name: "Cooking Methods", image: "images\\learn\\nutrition_icon_cooking.png", url: "html/nutrition/cooking-methods.html" },
    { id: 114, hasContent: true, parentID: 110, pageTitle: "Other Concerns", name: "Other Concerns", image: "images\\learn\\nutrition_icon_concerns.png", url: "html/nutrition/other-concerns.html" },
    { id: 115, hasContent: true, parentID: 110, pageTitle: "Fluids", name: "Fluids", image: "images\\learn\\nutrition_icon_fluids.png", url: "html/nutrition/fluids.html" },
    { id: 116, hasContent: true, parentID: 110, pageTitle: "Menu Plans", name: "7-day Menu Plan", image: "images\\nutrition\\menu-64x64.png", url: "html/nutrition/menu-plan.html" },
    { id: 117, hasContent: true, parentID: 104, pageTitle: "Exercising", name: "Exercising", image: "images\\learn\\treadmill-64x64.png", url: "html/caregiver/cg-04.html" },
    { id: 118, hasContent: true, parentID: 117, pageTitle: "Exercising", name: "Exercises for Veterans", url: "html/exercise/ex-home.html" },
    { id: 119, hasContent: true, parentID: 104, pageTitle: "Employment", name: "Making Your Job Work", image: "images\\learn\\at-work-64x64.png", url: "html/caregiver/cg-13.html" },
    { id: 120, hasContent: true, parentID: 104, pageTitle: "Preventing Illness", name: "Preventing Illness", image: "images\\learn\\bbleman-sick-cough-64x64.png", url: "html/caregiver/cg-07.html" },
    { id: 121, hasContent: true, parentID: 120, pageTitle: "Sleep Well", name: "Sleep Well", image: "images\\learn\\sleep-well-64x64.png", url: "html/caregiver/cg-08.html" },
    { id: 122, hasContent: true, parentID: 120, pageTitle: "Blood Pressure", name: "Watch Your Blood Pressure", image: "images\\learn\\blood-pressure-64x64.png", url: "html/caregiver/cg-09.html" },
    { id: 123, hasContent: true, parentID: 37, pageTitle: "Caregiver Tips", name: "Taking Care of a Veteran", image: "images\\learn\\Veteran-64x64.png", url: "html/caregiver/cg-18.html" },
    { id: 124, hasContent: true, parentID: 123, pageTitle: "ADLs and IADLs", name: "What are ADLs and IADLs?", url: "html/caregiver/cg-19.html", image: "images\\learn\\bbleman-scooter-64x64.png" },
    { id: 125, hasContent: true, parentID: 123, pageTitle: "Compensatory Skills", name: "What are compensatory skills?", url: "html/caregiver/cg-19a.html", image: "images\\learn\\driving2.png" },
    { id: 126, hasContent: true, parentID: 123, pageTitle: "Devices", name: "What is an assistive device?", url: "html/caregiver/cg-20.html", image: "images\\learn\\bbleman-walker-64x64.png" },
    { id: 127, hasContent: true, parentID: 123, pageTitle: "Pain Management", name: "What is pain management?", url: "html/caregiver/cg-23.html", image: "images\\learn\\bbleman-hurt-leg-64x64.png" },
    { id: 128, hasContent: true, parentID: 127, pageTitle: "Narcotics", name: "About Narcotic Pain Medicines", image: "images\\learn\\rx-bottles-64x64.png", url: "html/caregiver/cg-31.html" },
    { id: 129, hasContent: true, parentID: 123, pageTitle: "Medicines", name: "How should I manage medicines?", url: "html/caregiver/cg-22.html", image: "images\\learn\\rx-bottles-64x64.png" },
    { id: 130, hasContent: true, parentID: 123, pageTitle: "Vitals", name: "How do I take vital signs?", url: "html/caregiver/cg-25.html", image: "images\\learn\\blood-pressure-64x64.png" },
    { id: 131, hasContent: true, parentID: 123, pageTitle: "Home Safety", name: "How can I make the home safe?", url: "html/caregiver/cg-30.html", image: "images\\learn\\fall-dwn-stairs-64x64.png" },
    { id: 132, hasContent: true, parentID: 131, pageTitle: "Emergency Prep", name: "What if there's an emergency?", image: "images\\learn\\fireman-64x64.png", url: "html/caregiver/cg-30a.html" },
    { id: 133, hasContent: true, parentID: 123, pageTitle: "Communicate", name: "How can I communicate better?", url: "html/caregiver/cg-24.html", image: "images\\learn\\communicate-64x64.png" },
    { id: 134, hasContent: true, parentID: 123, pageTitle: "Protect Back", name: "How do I protect my back?", url: "html/caregiver/cg-10.html", image: "images\\learn\\lifting-box-64x64.png" },
    { id: 135, hasContent: true, parentID: 134, pageTitle: "Planning", name: "Planning the Lift", url: "html/caregiver/cg-11.html" },
    { id: 136, hasContent: true, parentID: 134, pageTitle: "Moving", name: "Moving the Veteran", url: "html/caregiver/cg-12.html" },
    { id: 137, hasContent: true, parentID: 123, pageTitle: "text", name: "What else can I do?", url: "html/caregiver/cg-21.html", image: "images\\learn\\bbleman-clipboard-64x64.png" },
    { id: 138, hasContent: false, parentID: 37, pageTitle: "Caregiver Tips", name: "Programs and Services", image: "images\\learn\\icon-VA-Seal-NTSC.png", url: "html/caregiver/cg-02.html" },
    { id: 139, hasContent: false, parentID: 138, pageTitle: "Post-9/11", name: "Post 9/11 Services", url: "html/caregiver/cg-02a.html" },
    { id: 140, hasContent: false, parentID: 138, pageTitle: "Support", name: "Caregiver Support Line", url: "html/caregiver/cg-02b.html" }
],
    schema: {
        model: { id: "id" }
    }
});



var referencesDataSource = new kendo.data.DataSource({
    data: [
 {source: "Center for Disease Control (CDC), Handwashing, last updated 12/11/2013 ", url: "http://www.cdc.gov/features/handwashing/ ", onclickURL : "http://www.cdc.gov/features/handwashing/ "},
{source: "Cheap protein foods, 2014, derived", url: "http://www.cuttystrength.com/11-cheapest-good-protein-sources", onclickURL : "http://www.cuttystrength.com/11-cheapest-good-protein-sources "},
{source: "Cheap protein foods, 2014, derived", url: "http://stronglifts.com/build-muscle-on-a-budget-the-10-cheapest-sources-of-protein", onclickURL : "http://stronglifts.com/build-muscle-on-a-budget-the-10-cheapest-sources-of-protein "},
{source: "Consortium for Spinal Cord Medicine, Copyright © 2002 Paralyzed Veterans of America printed copy", url: "Pressure Ulcers: What You Should Know.pdf", onclickURL : "" },
{source: "DID YOU KNOW? The Difference between Friction and Shear, Hess, Cathy Thomas BSN, RN, CWOCN Free and public content June 2014", url: "http://journals.lww.com/aswcjournal/pages/articleviewer.aspx?year=2004&issue=06000&article=00006&type=Fulltext", onclickURL : "http://journals.lww.com/aswcjournal/pages/articleviewer.aspx?year=2004&issue=06000&article=00006&type=Fulltext "},
{source: "Food Allergies and Intolerances - Disease Management and Prevention Information from the Academy, foodallergy-NIAID-NIH-GOV.pdf", url: "http://www.niaid.nih.gov/topics/foodallergy/Pages/default.aspx ", onclickURL : "http://www.niaid.nih.gov/topics/foodallergy/Pages/default.aspx "},
{source: "Food and nutrition content derived from Mayo Clinic", url: "http://www.mayoclinic.com/health/food-and-nutrition/NU00202", onclickURL : "http://www.mayoclinic.com/health/food-and-nutrition/NU00202 "},
{source: "How To Decide What Products..., 08/01/2013", url: "http://www.caregiverpartnership.com/blog/how-to-decide-what-incontinence-products-are-best-for-you-4603826099279896395 ", onclickURL : "http://www.caregiverpartnership.com/blog/how-to-decide-what-incontinence-products-are-best-for-you-4603826099279896395 "},
{source: "James A Haley VA Medical Center, Tampa, FL. Printed Handouts: Protect Yourself From Pressure Ulcers; Nutrition and Wound Healing; and High Calorie/High Protein Beverages.", url: "", onclickURL : " "},
{source: "List of High Protein Foods", url: "http://www.lose-weight-with-us.com/list-of-high-protein-foods.html", onclickURL : "http://www.lose-weight-with-us.com/list-of-high-protein-foods.html "},
{source: "National Pressure Ulcer Advisory Panel", url: "http://www.npuap.org/", onclickURL : "http://www.npuap.org/ "},
{source: "National Pressure Ulcer Advisory Panel", url: "http://www.npuap.org/wp-content/uploads/2012/02/Final_Quick_Prevention_for_web_2010.pdf", onclickURL : "http://www.npuap.org/wp-content/uploads/2012/02/Final_Quick_Prevention_for_web_2010.pdf "},
{source: "National Pressure Ulcer Advisory Panel", url: "http://www.npuap.org/resources/educational-and-clinical-resources/pressure-ulcer-prevention-points/", onclickURL : "http://www.npuap.org/resources/educational-and-clinical-resources/pressure-ulcer-prevention-points/ "},
{source: "National Pressure Ulcer Advisory Panel", url: "http://www.npuap.org/online-store/home.php?cat=249", onclickURL : "http://www.npuap.org/online-store/home.php?cat=249 "},
{source: "National Pressure Ulcer Advisory Panel, Best Practices for Prevention of Medical Device-Related Pressure Ulcers (PDF)", url: "", onclickURL : " "},
{source: "National Pressure Ulcer Advisory Panel, Pressure Ulcer Prevention Quick Reference Guide (PDF)", url: "", onclickURL : " "},
{source: "National Pressure Ulcer Advisory Panel, Pressure Ulcer Prevention Points (PDF)", url: "", onclickURL : " "},
{source: "Portions and Servings, 01/10/2013", url: "http://www.heart.org/HEARTORG/GettingHealthy/WeightManagement/LosingWeight/Dont-Fall-Prey-to-Portion-Distortion_UCM_424567_Article.jsp", onclickURL : "http://www.heart.org/HEARTORG/GettingHealthy/WeightManagement/LosingWeight/Dont-Fall-Prey-to-Portion-Distortion_UCM_424567_Article.jsp "},
{source: "Resistance Band Wheelchair Exercises", url: "http://motherhood.modernmom.com/resistant-band-wheelchair-exercises-9376.html", onclickURL : "http://motherhood.modernmom.com/resistant-band-wheelchair-exercises-9376.html "},
{source: "Tables with Protein and Calorie Counts, List of High Protein Foods", url: "http://www.lose-weight-with-us.com/list-of-high-protein-foods.html ", onclickURL : "http://www.lose-weight-with-us.com/list-of-high-protein-foods.html "},
{source: "The Free Dictionary Online", url: "http://medical-dictionary.thefreedictionary.com/p/pressure%20ulcer", onclickURL : "http://medical-dictionary.thefreedictionary.com/p/pressure%20ulcer "},
{source: "The Free Dictionary Online", url: "http://medical-dictionary.thefreedictionary.com/wound+irrigation", onclickURL : "http://medical-dictionary.thefreedictionary.com/wound+irrigation "},
{source: "The Healthiest Cooking Methods Explained by Kathryn Seigel, Feb 1, 2013, reprinted with permission", url: "http://healthland.time.com/2013/02/01/the-healthiest-cooking-methods-explained/", onclickURL : "http://healthland.time.com/2013/02/01/the-healthiest-cooking-methods-explained/ "},
{source: "Turner, P. BSN, RN, CWOCN, CWS. (2013). Apples to Ulcers, Tips for Staging Pressure Ulcers, reused with permission", url: "http://mkt.medline.com/clinical-blog/channels/clinical-solutions/apples-to-ulcers-tips-for-staging-pressure-ulcers/", onclickURL : "http://mkt.medline.com/clinical-blog/channels/clinical-solutions/apples-to-ulcers-tips-for-staging-pressure-ulcers/ "},
{source: "U.S. Department of Agriculture, Choose My Plate", url: "http://www.choosemyplate.gov/", onclickURL : "http://www.choosemyplate.gov/ "},
{source: "U.S. Department of Health and Human Services, Agency for Healthcare Research and Quality", url: "http://guideline.gov/", onclickURL : "http://guideline.gov/ "},
{source: "U.S. Department of Veterans Affairs", url: "https://www.myhealth.va.gov/", onclickURL : "https://www.myhealth.va.gov/ "},
{source: "U.S. Department of Veterans Affairs, Handouts, printed copies: Long Distance Caregiving (PDF), date unknown; Questions to Ask a Veterans Health Care Team (PDF), date unknown; Tips for Communicating with a Veteran (PDF), date unknown; 5 Tips to Avoid Caregiver Burnout (PDF), 2012; 50 Things Every Caregiver Should Know  (PDF), 2012; Balancing Caregiving, Family, and Work  (PDF), 2012; Caring for the Caregiver  (PDF), 2012; Rewards of Caregiving  (PDF), 2012", url: "", onclickURL : " "},
{source: "U.S. Department of Veterans Affairs, Caregiver Workbook V3 Module 1", url: "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_1.pdf", onclickURL : "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_1.pdf "},
{source: "U.S. Department of Veterans Affairs, Caregiver Workbook V3 Module 2", url: "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_2.pdf", onclickURL : "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_2.pdf "},
{source: "U.S. Department of Veterans Affairs, Caregiver Workbook V3 Module 3", url: "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_3.pdf", onclickURL : "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_3.pdf "},
{source: "U.S. Department of Veterans Affairs, Caregiver Workbook V3 Module 4", url: "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_4.pdf", onclickURL : "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_4.pdf "},
{source: "U.S. Department of Veterans Affairs, Caregiver Workbook V3 Module 5", url: "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_5.pdf", onclickURL : "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_5.pdf "},
{source: "U.S. Department of Veterans Affairs, Caregiver Workbook V3 Module 6", url: "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_6.pdf", onclickURL : "http://www.caregiver.va.gov/pdfs/Caregiver_Workbook_V3_Module_6.pdf "},
{source: "U.S. Department of Veterans Affairs", url: "http://www.va.gov/vhapublications/ViewPublication.asp?pub_ID=2422", onclickURL : "http://www.va.gov/vhapublications/ViewPublication.asp?pub_ID=2422 "},
{source: "U.S. Department of Veterans Affairs", url: "www.houston.va.gov/PatientEd/documents/Pressure_Ulcer_Trifold.doc", onclickURL : "www.houston.va.gov/PatientEd/documents/Pressure_Ulcer_Trifold.doc "},
{source: "U.S. Department of Veterans Affairs", url: "", onclickURL : " "},
{source: "U.S. Department of Veterans Affairs, Printed Handout: Defense and Veterans Pain Rating Scale Version 2.0.pdf", url: "", onclickURL : " "},
{source: "U.S. Department of Veterans Affairs, Printed Handout: Prevention of Pressure Ulcers, VHA HANDBOOK 1180.02.pdf", url: "", onclickURL : " "},
{source: "What is Moisture Wicking Fabric, undated article", url: "http://www.wisegeek.org/what-is-moisture-wicking-fabric.htm", onclickURL : "http://www.wisegeek.org/what-is-moisture-wicking-fabric.htm "},
{source: "Wound and Pressure Ulcer Management by Sharon DeMarco, CRNP, public content", url: "http://www.hopkinsmedicine.org/gec/series/wound_care.html", onclickURL : "http://www.hopkinsmedicine.org/gec/series/wound_care.html "}

    ]
})



// Get Saved MyDoctor and MyFacility data.  used in multiple places

var mySavedFacilityData;

function loadSavedMyFacilityData() {

    var savedData = window.localStorage.getItem("SavedMyFacilityData");

    if (savedData && savedData.length > 10) {


        mySavedFacilityData = jQuery.parseJSON(savedData);

    }
}

function getMyFacilityValueForKey(keyName) {

    loadSavedMyFacilityData();
    var savedData = mySavedFacilityData;
   
    if (savedData && savedData.length > 5) {


        var jsonObject = savedData;

        for (var i = 0; i < jsonObject.length; i++) {
            if (jsonObject[i].Label === keyName) {
             
                return jsonObject[i].Value.replace(/-/g, "");;
            }
        }

    }

    return "";
}


function getKey() {

    var key = window.localStorage.getItem("myKey");

    if (!key) {
        key = intGuid();
        window.localStorage.setItem("myKey", key);
    }
    console.log("Key: " + key);
    return key;
}