// IE Mobile 10.0 fix
// (add to separate js file and inlcude in head of all pages)
(function () {
    if (navigator.userAgent.match(/IEMobile\/10\.0/)) {
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
            document.createTextNode(
                "@-ms-viewport{width:auto!important}"
            )
        );
        document.querySelector('head').appendChild(msViewportStyle);
    }
}) ();

(function loadGlossaryItems() {
    if (typeof (Storage) !== "undefined") {
        if (!sessionStorage.glossaryItems) {
            // load glossary items into JSON object variable
            $.getJSON("data/glossary.json", function (data) {
                sessionStorage.glossaryItems = JSON.stringify(data);
            });
        }
    }
})();

(function loadSettings() {
    if (typeof (Storage) !== "undefined") {
        if (!sessionStorage.settings) {
            // load glossary items into JSON object variable
            $.getJSON("data/settings.json", function (data) {
                sessionStorage.settings = JSON.stringify(data);
            });
        }
    }
})();

(function loadSourceReferences() {
    if (typeof (Storage) !== "undefined") {
        if (!sessionStorage.sourceReferenceList || !sessionStorage.pageSourceReferences) {
            // load source references into JSON object variables
            $.getJSON("data/source-reference-list.json", function (data) {
                sessionStorage.sourceReferenceList = JSON.stringify(data);
                $.getJSON("data/page-source-references.json", function (data) {
                    sessionStorage.pageSourceReferences = JSON.stringify(data);
                });
            });
        }
    }
}) ();


//function onDeviceReady() {
  //  if (device.platform === 'iOS' && parseFloat(device.version) >= 7.0) {
       // document.body.style.marginTop = "20px";
     //   }
//}

    //document.addEventListener('deviceready', onDeviceReady, false);

// document.addEventListener('deviceready', function () {
//        navigator.splashscreen.hide(); //Hides the splash screen for your app.
//        StatusBar.overlaysWebView(false); //Turns off web view overlay.

       

//}, false);

// initialization
$(document).ready(function () {

    //bindPopoverToTaggedItems();

    bindClickEventToFlipCards();

    //if (device.platform === 'iOS' && parseFloat(device.version) >= 7.0) {

     document.body.style.marginTop = "20px";

   // navigator.splashscreen.hide(); //Hides the splash screen for your app.
    //StatusBar.overlaysWebView(false); //Turns off web view overlay.
   // }
    // add check for masonry defined. If not then don't try to run it.




// var tooltipOptions = {
//     trigger: 'manual',
//     title: function() {
//       return help[$(this).attr('data-help')].title;
//     },
//     content: function() {
//       return help[$(this).attr('data-help')].description;
//     }
  // };

});


$(window).load(function() {

    // maybe add check for masonry object

    $('#cards-masonry').masonry({
        itemSelector: '.card-standard',
        columnWidth: '.card-standard'
    });

});

function bindPopoverToTaggedItemsOld() {

            // add click event handler to remove popover on another popover click event and window resize
            // use fiddle as an example - http://jsfiddle.net/AFffL/685/

            // refactor to use id lookup instead of for loop??
            // http://stackoverflow.com/questions/1946165/json-find-in-javascript

            // Bootstrap popovers assigned to .glossaryItems placed inside a <span> element
    $.each($('span.glossaryItem'), function (index, element) {
       
                $(element).popover({
                    placement: 'auto top',
                    //trigger: 'manual',           // add back in with click event handler
                    title: function () {
                        if (sessionStorage.glossaryItems) {
                            var glossaryItems = $.parseJSON(sessionStorage.glossaryItems);
                            for (var i = 0; i < glossaryItems.length; i++) {
                                if (glossaryItems[i].id === $(element).attr("id")) return glossaryItems[i].title;
                            }
                        }
                        else return "Unavailable";                              // glossary items object not defined
                        return "Unknown";                                       // cannot find glossary item in object
                    },
                    content: function () {
                        if (sessionStorage.glossaryItems) {
                            var glossaryItems = $.parseJSON(sessionStorage.glossaryItems);
                            for (var i = 0; i < glossaryItems.length; i++) {
                                if (glossaryItems[i].id === $(element).attr("id")) return glossaryItems[i].content;
                            }
                        }
                        else return "Glossary is currently unavailable.";       // glossary items object not defined
                        return "Item cannot be found in glossary.";             // cannot find glossary item in object
                    }
                    //, container: 'span'                   // original container
                });
            });

        }

        function bindClickEventToFlipCards() {

            $.each($('.card-content.card-flip'), function(index, element) {
                $('#' + element.id).on('click', function() {
                    $('#' + element.id + ' .front').toggleClass('front-flip');
                    $('#' + element.id + ' .back').toggleClass('back-flip');
                });
            });
        }





// fix this function
function addAboutReferences() {

    var sourceReferenceList = $.parseJSON(sessionStorage.sourceReferenceList);
    var sourceReferences = "";

    if (sourceReferenceList.length !== 0) {
        for (var i = 0; i < sourceReferenceList.length; i++) {
            sourceReferences = sourceReferences + "<li>" + sourceReferenceList[i].reference + "</li>";
        }
        $('#references').append(sourceReferences);
    }
}
